
function UniteCreatorGridBuilder_addonHTML(){
	
	var g_objGrid; //for the autocomplete
	var t = this;
	
	if (!g_ucAdmin)
		var g_ucAdmin = new UniteAdminUC();
	
	
	this.____________ADDON_HTML______________ = function() {}

	
	/**
	 * get the html
	 */
	this.generateAddonHtml_wrapAddonHtml = function(addon_name, htmlAddon, addonData, onlyInner) {
		
		
		if (!onlyInner)
			var onlyInner = false;

		var classAdd = "";

		var addonType = g_ucAdmin.getVal(addonData, "addontype");
		var isBGAddon = (addonType == g_objGrid.g_temp.addontype_bgaddon);
		
		var serialID = addonData.extra.serial_id;
		var addonID = g_objGrid.g_vars.id_prefix + serialID;
				
		var html = "";

		// get html of bg addon
		if (isBGAddon == true) {

			if (onlyInner == false)
				html += "		<div id='" + addonID
						+ "' class=\"uc-grid-bg-addon\" data-name='"
						+ addon_name + "'>";

			html += htmlAddon;

			if (onlyInner == false)
				html += "		</div>";

			return (html);
		}

		// regular addon

		if (onlyInner == false)
			html += "		<div id='"
					+ addonID
					+ "' class=\"uc-grid-col-addon uc-grid-addon-sortable\" data-name='"
					+ addon_name + "'>";

		html += "			<div class=\"uc-grid-col-addon-html unite-clearfix "
				+ classAdd + "\" >";

		html += htmlAddon;

		html += "			</div>";

		html += "			<div class='uc-grid-element-hidden-overlay'>"
				+ g_uctext.hidden_addon + "</div>";

		html += "			<div class=\"uc-grid-addon-hover uc-hover-left uc-grid-extras\" ></div>";
		html += "			<div class=\"uc-grid-addon-hover uc-hover-right uc-grid-extras\" ></div>";
		html += "			<div class=\"uc-grid-addon-hover uc-hover-top uc-grid-extras\" ></div>";
		html += "			<div class=\"uc-grid-addon-hover uc-hover-bottom uc-grid-extras\" ></div>";

		html += "			<div class='uc-grid-object-panel uc-grid-addon-panel uc-grid-extras'>";
		html += "					<a href=\"javascript:void(0)\" data-actiontype='addon' data-action='delete_addon' title=\""
				+ g_uctext.delete_addon
				+ "\" class=\"uc-grid-action-icon \"><i class=\""
				+ g_objGrid.getIcon("delete") + "\" aria-hidden=\"true\"></i></a>";
		html += "					<a href=\"javascript:void(0)\" data-actiontype='addon' data-action='addon_container_settings' title=\""
				+ g_uctext.addon_container_settings
				+ "\" class=\"uc-grid-action-icon \"><i class=\""
				+ g_objGrid.getIcon("settings") + "\" aria-hidden=\"true\"></i></a>";
		html += "					<a href=\"javascript:void(0)\" data-actiontype='addon' data-action='edit_addon' title=\""
				+ g_uctext.edit_addon
				+ "\" class=\"uc-grid-action-icon \"><i class=\""
				+ g_objGrid.getIcon("edit") + "\" aria-hidden=\"true\"></i></a>";
		html += "					<a href=\"javascript:void(0)\" data-actiontype='addon' data-action='duplicate_addon' title=\""
				+ g_uctext.duplicate_addon
				+ "\" class=\"uc-grid-action-icon \"><i class=\""
				+ g_objGrid.getIcon("duplicate") + "\" aria-hidden=\"true\"></i></a>";
		html += "					<a href='javascript:void(0)' title='"
				+ g_uctext.move_addon
				+ "' class=\"uc-addon-icon-move uc-grid-icon-move uc-tip\"><i class=\""
				+ g_objGrid.getIcon("move") + "\" aria-hidden=\"true\"></i></a> ";
		html += "					<a href=\"javascript:void(0)\" data-actiontype='addon' data-action='add_col_addon' title='"
				+ g_uctext.add_addon_to_column
				+ "' class=\"uc-grid-action-icon \"><i class=\"fa fa-plus\" aria-hidden=\"true\"></i></a>";

		html += "			</div>";

		// html += " <a href='javascript:void(0)' onfocus='this.blur()'
		// data-action='add_col_addon' data-actiontype='addon'
		// title='"+g_uctext.add_addon_to_column+"' class=\"uc-col-icon
		// uc-grid-action-icon uc-tip uc-icon-add-more-addon uc-grid-extras\"
		// style='display:none'><span class='uc-btn uc-btn-square
		// uc-btn-addon'><i class=\"fa fa-plus\"
		// aria-hidden=\"true\"></i></span></a> ";

		if (onlyInner == false)
			html += "		</div>";

		return (html);
	}

	/**
	 * get box html desciprion, by values and admin labels
	 */
	this.getBoxHtmlDescription = function(addonData) {

		var extra = g_ucAdmin.getVal(addonData, "extra");

		var adminLabels = g_ucAdmin.getVal(extra, "admin_labels");
		var config = g_ucAdmin.getVal(addonData, "config");
		var items = g_ucAdmin.getVal(addonData, "items");

		if (!adminLabels || adminLabels.length == 0)
			return ("");

		// combine description

		var desc = "";

		jQuery.each(adminLabels,
				function(index, arrLabel) {

					var value = "";

					var key = arrLabel[0];
					var title = arrLabel[1];

					// take number of items
					if (key == "uc_num_items") {
						var numItems = 0;
						if (typeof items == "object")
							numItems = items.length;

						desc = numItems + " " + title;
						return (true);
					}

					// get from config
					value = g_ucAdmin.getVal(config, key);

					// check for value2 (select field alternative)
					var value2 = g_ucAdmin.getVal(config, key
							+ "_unite_selected_text");
					if (value2)
						value = value2;

					else { // check for post field

						var value2 = g_ucAdmin.getVal(config, key
								+ "_post_title");
						if (value2)
							value = value2;
					}

					value = jQuery.trim(value);
					value = g_ucAdmin.stripTags(value, "b,strong,i");

					if (!value || value == "")
						return (true);

					if (desc)
						desc += " | ";

					desc += title + ": " + value;

				});

		return (desc);
	}

	
	/**
	 * get box view html
	 */
	this.generateAddonHtml_getBoxHtml = function(url_icon, title, addonData) {

		url_icon = g_ucAdmin.escapeDoubleQuote(url_icon);
		title = g_ucAdmin.htmlspecialchars(title);

		var description = t.getBoxHtmlDescription(addonData);

		// title = addonData.extra.serial_id; //remove me

		html = "";
		html += "				<img src=\"" + url_icon + "\">";
		html += "				<span class='uc-grid-addon-title'>" + title + "</span>";

		if (description)
			html += "				<span class='uc-grid-addon-description'>"
					+ description + "</span>";

		return (html);
	}

	/**
	 * put addon includes
	 */
	this.putAddonLiveModeIncludes = function(addonData, objIncludes, funcOnLoaded) {

		var isLoadOneByOne = true;

		var serialID = addonData.extra.serial_id;

		var handlePrefix = "uc_include_";

		g_ucAdmin.validateNotEmpty(serialID, "serial ID");

		// make a list of js handles
		var arrHandles = {};
		jQuery.each(objIncludes, function(event, objInclude) {

			var handle = handlePrefix + objInclude.type + "_"
					+ objInclude.handle;

			if (!(objInclude.type == "js" && objInclude.handle == "jquery"))
				arrHandles[handle] = objInclude;
		});

		var isAllFilesLoaded = false;

		// inner function that check that all files loaded by handle
		function checkAllFilesLoaded() {

			if (isAllFilesLoaded == true)
				return (false);

			if (!jQuery.isEmptyObject(arrHandles))
				return (false);

			isAllFilesLoaded = true;

			if (!funcOnLoaded)
				return (false);

			funcOnLoaded();

		}

		/**
		 * on js file loaded - load first js file, from available handles in
		 * case that loading one by one
		 */
		function onJsFileLoaded() {

			for ( var index in arrHandles) {
				var objInclude = arrHandles[index];

				if (objInclude.type == "js") {
					loadIncludeFile(objInclude);
					return (false);
				}

			}

		}

		/**
		 * load include file
		 */
		function loadIncludeFile(objInclude) {

			var url = objInclude.url;
			var handle = handlePrefix + objInclude.type + "_"
					+ objInclude.handle;
			var type = objInclude.type;

			// skip jquery for now
			if (objInclude.handle == "jquery") {

				checkAllFilesLoaded();

				if (isLoadOneByOne)
					onJsFileLoaded();

				return (true);
			}

			var data = {
				replaceID : handle,
				name : "uc_include_file"
			};

			// onload throw event when all scripts loaded
			data.onload = function(obj, handle) {

				var objDomInclude = jQuery(obj);

				objDomInclude.data("isloaded", true);

				// delete the handle from the list, and check for all files
				// loaded
				if (arrHandles.hasOwnProperty(handle) == true) {

					delete arrHandles[handle];

					checkAllFilesLoaded();

				}// end checking

				if (isLoadOneByOne) {
					var tagName = objDomInclude.prop("tagName").toLowerCase();
					if (tagName == "script")
						onJsFileLoaded();
				}

			};

			// if file not included - include it
			var objDomInclude = jQuery("#" + handle);

			if (objDomInclude.length == 0) {

				objDomInclude = g_ucAdmin.loadIncludeFile(type, url, data);
			} else {

				// if the files is in the loading list but still not loaded,
				// wait until they will be loaded and then check for firing the
				// finish event (addons with same files)

				// check if the file is loaded
				var isLoaded = objDomInclude.data("isloaded");
				if (isLoaded == true) {

					// if it's already included - remove from handle
					if (arrHandles.hasOwnProperty(handle) == true)
						delete arrHandles[handle];

					if (isLoadOneByOne) {
						var tagName = objDomInclude.prop("tagName")
								.toLowerCase();
						if (tagName == "script")
							onJsFileLoaded();
					}

				} else {

					var timeoutHandle = setInterval(function() {
						var isLoaded = objDomInclude.data("isloaded");

						if (isLoaded == true) {
							clearInterval(timeoutHandle);

							if (arrHandles.hasOwnProperty(handle) == true)
								delete arrHandles[handle];

							checkAllFilesLoaded();

							if (isLoadOneByOne) {
								var tagName = objDomInclude.prop("tagName")
										.toLowerCase();
								if (tagName == "script")
									onJsFileLoaded();
							}

						}

					}, 100);

				}

			}

			// add addon serialID to the include
			var arrSerials = objDomInclude.data("serials");

			if (!arrSerials)
				arrSerials = {};

			if (arrSerials.hasOwnProperty(serialID) == false)
				arrSerials[serialID] = true;

			objDomInclude.data("serials", arrSerials);

		}

		if (isLoadOneByOne == false) {

			jQuery.each(objIncludes, function(event, objInclude) {
				loadIncludeFile(objInclude);
			});

		} else {

			// load css files and first js files
			var isFirstJS = true;

			jQuery.each(objIncludes, function(event, objInclude) {
				if (objInclude.type == "css")
					loadIncludeFile(objInclude);
				else { // js file, load first only

					if (isFirstJS == true) {
						loadIncludeFile(objInclude);
						isFirstJS = false;
					}

				}
			});

		}

		// check if all files loaded
		checkAllFilesLoaded();

	}

	/**
	 * check and remove addon includes if needed this function called on addon
	 * delete
	 */
	this.checkRemoveLiveModeIncludes = function() {

		var objIncludes = jQuery("script[name='uc_include_file']").add(
				"link[name='uc_include_file']");

		// check if there is addon serial in include.
		// if do - remove it, if no more serials - delete the include

		jQuery.each(objIncludes, function(event, objInclude) {

			objInclude = jQuery(objInclude);
			var arrSerials = objInclude.data("serials");

			jQuery.each(arrSerials, function(serial, value) {

				// search addon by id
				var addonID = g_objGrid.g_vars.id_prefix + serial;
				var objAddon = jQuery("#" + addonID);
				if (objAddon.length == 0)
					delete arrSerials[serial];
			});

			if (jQuery.isEmptyObject(arrSerials)) {

				objInclude.remove();

			} else { // insert serials data bacl
				objInclude.data("serials", arrSerials);
			}

		});

	}

	/**
	 * modify addon html, replace the id's to unique the html is get from server
	 */
	this.modifyAddonLiveHtml = function(html, addonData, outputData) {
		
		var resultID = addonData.extra.serial_contentid;

		var constants = g_ucAdmin.getVal(outputData, "constants");
		var sourceID = g_ucAdmin.getVal(constants, "uc_id");

		if (!sourceID || !resultID)
			return (html);

		// modify only if there is addon like this already
		var existingElement = jQuery("#" + sourceID);
		if (existingElement.length == 0)
			return (html);

		html = g_ucAdmin.replaceAll(html, sourceID, resultID);

		return (html);
	}

	/**
	 * handle output data when generate html
	 */
	this.generateAddonHtml_handleAddonOutputData = function(outputData, addonData, onFinish, onlyInner){
		
		var addon_name = addonData.name;

		var htmlLive = g_ucAdmin.getVal(outputData, "html");

		htmlLive = t.modifyAddonLiveHtml(htmlLive, addonData, outputData);

		var objIncludes = g_ucAdmin.getVal(outputData, "includes");
		var objConstants = g_ucAdmin.getVal(outputData, "constants");

		// replace constants in html
		var htmlColAddon = t.generateAddonHtml_wrapAddonHtml(addon_name, htmlLive, addonData, onlyInner);

		// put includes, on all scripts loaded put html
		t.putAddonLiveModeIncludes(addonData, objIncludes, function() {

			// put html
			onFinish(htmlColAddon);
		});

	}
	
	/**
	 * generate addon html after finish, call a function
	 */
	this.generateAddonHtml = function(addonData, onFinish, onlyInner) {

		var arrExtra = g_ucAdmin.getVal(addonData, "extra");

		var title = g_ucAdmin.getVal(arrExtra, "title");
		var url_icon = g_ucAdmin.getVal(arrExtra, "url_icon");
		var addon_name = addonData.name;

		if (!title)
			title = addon_name;

		if (onFinish && typeof onFinish != "function")
			throw new Error("The second param should be a function");

		var addontype = g_ucAdmin.getVal(addonData, "addontype");
		var isBGAddon = false;
		if (addontype == g_objGrid.g_temp.addontype_bgaddon)
			isBGAddon = true;

		// box view
		if (g_objGrid.g_temp.is_live_view == false) {

			if (isBGAddon == true) {
				htmlColAddon = title;
			} else {
				var htmlBox = t.generateAddonHtml_getBoxHtml(url_icon, title, addonData);
				var htmlColAddon = t.generateAddonHtml_wrapAddonHtml(addon_name, htmlBox, addonData, onlyInner);
			}

			if (onFinish)
				onFinish(htmlColAddon);
			else
				return (htmlColAddon);

		} else { // live view

			if (typeof onFinish != "function")
				throw new Error("The second param should be a function");

			// do without ajax
			var output = g_ucAdmin.getVal(addonData, "output");

			if (output) {
				t.generateAddonHtml_handleAddonOutputData(output, addonData, onFinish, onlyInner);
			} else { // call ajax

				if (jQuery.isArray(addonData.items) == true
						&& addonData.items.length == 0)
					addonData.items = g_objGrid.g_temp.value_empty_array;

				g_ucAdmin.ajaxRequest("get_addon_output_data", addonData, function(response) {
							
							// save output data
							addonData["output"] = response;
							t.generateAddonHtml_handleAddonOutputData(response, addonData, onFinish, onlyInner);
					});
			}

		}

	}

	
	/**
	 * set duplicated addon html, before insert it into dome
	 */
	this.setDuplicatedAddonHtml = function(objAddon, addonData) {
		
		delete addonData["output"];

		var addonID = g_objGrid.g_vars.id_prefix + addonData.extra.serial_id;
		objAddon.attr("id", addonID);

		if (g_objGrid.g_temp.is_live_view == false) { // box view

			var newHTML = t.generateAddonHtml(addonData, null, true);
			objAddon.html(newHTML);

		} else {
			
			t.generateAddonHtml(addonData, function(newHTML) {
				objAddon.html(newHTML);
			}, true);
			
		}

	}
	
	
	/**
	 * init the grid data
	 */
	this.init = function(objGrid){
				
		g_objGrid = objGrid;
	}
	
}
