
function UniteCreatorGridBuilder_dragDrop(){
	
	//var g_objGrid = new UniteCreatorGridBuilder(); //for the autocomplete
	var g_objGrid; //for the autocomplete
	var g_objGridWrapper, g_objBuilderWrapper, g_objDraggingObject;
	var g_objBodyParent, g_objIframe, g_objTempIndicator;
	
	//var g_objGrid; //for the autocomplete
	var t = this;
	
	if (!g_ucAdmin)
		var g_ucAdmin = new UniteAdminUC();
	
	var g_vars = {
		class_drag_mode:"uc-drag-mode",
		class_dragging_source: "uc-dragging-source",
		class_dragging_placeholder: "uc-dragging-placeholder",
		dragging_object_offsetX:30,
		dragging_object_offsetY:30
	};
	
	var g_temp = {
		is_drag_mode:false,
		frame_offset_x:0,
		frame_offset_y:0,
		body_offset_y:0,
		body_offset_x:0,
		element_source:null,
		page_mouse_x:0,		//page mouse position - fixed
		page_mouse_y:0,
		grid_mouse_x:0,		//grid mouse absolute position
		grid_mouse_y:0,
		placeholder_positions:{},
		current_col:null,
		current_col_id:null,
		current_mouseover_element:null
	}; 
	 
	this.____________DRAG_DROP______________ = function() {}
	 
	/**
	 * init iframe offsets
	 */
	function saveFrameOffsets(){
		
		var objOffset = g_objIframe.offset();
		g_temp.frame_offset_x = objOffset.left;
		g_temp.frame_offset_y = objOffset.top;
		
		g_temp.body_offset_y = Math.round(jQuery(document).scrollTop());
		g_temp.body_offset_x = Math.round(jQuery(document).scrollLeft());
		
	}
	
	
	/**
	 * get addon title
	 */
	function getAddonTitle(){
		
		var addonData = g_objGrid.g_objGridData.getColAddonData(g_temp.element_source);
		
		if(!addonData)
			return("");
		
		var extra = g_ucAdmin.getVal(addonData, "extra");
		var title  = g_ucAdmin.getVal(extra, "title");
		
		if(!title)
			title = "Addon";
				
		return(title);
	}
	
	/**
	 * show debug
	 */
	function showDebug(str){
		
		g_objGrid.showDebug(str);
	}
	
	/**
	 * go to drag mode
	 */
	function startDragMode(objSourceElement){
						
		g_temp.is_drag_mode = true;
		
		g_temp.element_source = objSourceElement;
		
		g_objGridWrapper.addClass(g_vars.class_drag_mode);
		
		g_temp.element_source.addClass(g_vars.class_dragging_source);
		
		putActivePlaceholderDiv(objSourceElement, "bottom");
		
		g_temp.placeholder_positions = {};
		g_temp.current_col = null;
		g_temp.current_col_id = null;
		g_temp.current_mouseover_element = null;
		
		//set iframe offsets
		saveFrameOffsets();
		
		var addonTitle = getAddonTitle();
		
		//set dragging object		
		g_objDraggingObject.html(addonTitle);
		g_objDraggingObject.show();
		
		positionDraggingObject();
		
	}
	

	/**
	 * trigger update columns events
	 */
	function stopDragMode_triggerUpdateColumns(colSource, colDest){
		
		g_objGrid.triggerEvent(g_objGrid.events.COL_ADDONS_UPDATED, colSource);
		
		if(colSource.prop("id") !== colDest.prop("id"))
			g_objGrid.triggerEvent(g_objGrid.events.COL_ADDONS_UPDATED, colDest);
		
	}
	
	
	/**
	 * check placeholder, if need to move the addon, and then remove it
	 */
	function stopDragMode_checkPlaceholder(){
		
		var objSource = g_temp.element_source;
		
		if(!objSource)
			throw new Error("Should be addon source!");			

		var colSource = g_objGrid.getParentCol(objSource);		
		
		//add addon on empty column
		var isEmptyColumn = isCurrentColEmpty();
				
		if(isEmptyColumn == true){
			removeAllPlaceholders();
			
			var objColumn = g_temp.current_col;
						
			var objAddonsWrapper = objColumn.find(".uc-grid-col-addons");
			
			objAddonsWrapper.append(objSource);
			
			stopDragMode_triggerUpdateColumns(colSource, objColumn);
			
			return(false);
		}
		
		//add on the placeholder
		var objPlaceholder = g_objGridWrapper.find("."+g_vars.class_dragging_placeholder);
		
		var colDest = g_objGrid.getParentCol(objPlaceholder);
		
		if(objPlaceholder.length == 0)
			return(false);
		
		if(objPlaceholder.length > 1){
			objPlaceholder.remove();
			throw new Error("Should be only 1 placeholder");			
		}
		
		var sourceID = objSource.prop("id");
		
		var nextElement = objPlaceholder.next();
		var prevElement = objPlaceholder.prev();
		
		var nextID = nextElement.prop("id");
		var prevID = prevElement.prop("id");
		
		//if in place, then just delete the placeholder. The source element is displayed
		if(nextID === sourceID || prevID == sourceID){
			objPlaceholder.remove();
			return(false);
		}
		
		//replace the placeholder
		objPlaceholder.replaceWith(objSource);
		
		stopDragMode_triggerUpdateColumns(colSource, colDest);
		
	}
	
	
	/**
	 * stop drag mode
	 */
	function stopDragMode(){
		
		if(g_temp.is_drag_mode == false)
			return(true);
		
		g_temp.is_drag_mode = false;
		
		g_temp.element_source.removeClass(g_vars.class_dragging_source);
				
		g_objGrid.hideDebug();
		
		g_objGridWrapper.removeClass(g_vars.class_drag_mode);
		
		g_objDraggingObject.hide();
		
		stopDragMode_checkPlaceholder();
		
		g_temp.placeholder_positions = {};		
		g_temp.current_col = null;
		g_temp.current_col_id = null;
	}
	
	
	/**
	 * save parent mouse position from local event
	 */
	function saveParentMousePos(event){
		
		g_temp.page_mouse_x = event.pageX + g_temp.frame_offset_x;
		g_temp.page_mouse_y = event.pageY + g_temp.frame_offset_y;		
	}
	
	/**
	 * remove all other placeholders
	 */
	function removeAllPlaceholders(){
		
		var objPlaceholders = g_objGridWrapper.find("."+g_vars.class_dragging_placeholder);
		
		objPlaceholders.remove();
	}
	
	function ____________WHILE_MOVING______________(){}
	
	
	/**
	 * position temp mouse cursor indicator
	 */
	function positionTempIndicator(posY){
		
		if(!g_objTempIndicator)
			return(false);
		
		if(!posY)
			var posY = g_temp.grid_mouse_y+10;
		
		g_objTempIndicator.css({
			"top":posY+"px",
			"left":g_temp.grid_mouse_x+10+"px"
		});
		
	}
	
	/**
	 * position dragging object according the page coordinates
	 */
	function positionDraggingObject(){
		
		var posX = g_temp.page_mouse_x - g_vars.dragging_object_offsetX;
		var posY = g_temp.page_mouse_y - g_vars.dragging_object_offsetY;
		
		g_objDraggingObject.css({
			top: posY+"px",
			left: posX+"px"
		});
		
	}
	
	/**
	 * add / remove selected class to the column where the mouse in
	 */
	function operateMouseColumn(){
		
		var classHover = g_objGrid.g_vars.class_element_hover;
						
		var element = document.elementFromPoint(g_temp.grid_mouse_x, g_temp.grid_mouse_y);
		var objElement = jQuery(element);
				
		var objCol = g_objGrid.getParentCol(objElement);
		
		var markedCols = g_objGridWrapper.find("."+g_objGrid.g_vars.class_col + "."+g_objGrid.g_vars.class_element_hover).not(objCol);
		
		if(markedCols.length)
			markedCols.removeClass(classHover);
		
		if(objCol.length == 0){
			g_temp.current_col_id = null;
			g_temp.current_col = null;
			g_temp.current_mouseover_element = null;
			return(null);
		}
		
		g_temp.current_mouseover_element = objElement;
		
		if(objCol.hasClass(classHover) == false)
			objCol.addClass(classHover);
		
		//set positions
		var colID = objCol.attr("id");		
		g_temp.current_col_id = colID;
		g_temp.current_col = objCol;
		
		var hasPositions = g_temp.placeholder_positions.hasOwnProperty(colID);
		
		if(hasPositions === false)
			g_temp.placeholder_positions[colID] = getColPlaceholderPositions(objCol);
		
		return(objCol);
	}
	
	/**
	 * get columns placeholder positions
	 */
	function getColPlaceholderPositions(objCol){
		
		var arrPositions = [];
		
		var objAddons = g_objGrid.getColAddons(objCol);
		if(objAddons.length == 0)
			return(arrPositions);
				
		objAddons.each(function(index, addon){
			
			var objAddon = jQuery(this);
			if(objAddon.hasClass(g_vars.class_dragging_source) == true)
				return(true);
			
			var offset = objAddon.offset();
			var offsetTop = Math.round(offset.top);
			var offsetBottom = offsetTop + objAddon.height();
			
			//remember the top to first addon only
			if(arrPositions.length == 0)
				arrPositions.push({
					posy: offsetTop,
					addon: objAddon,
					position:"top"
				});
			
			//add the bottom
			arrPositions.push({
					posy: offsetBottom,
					addon: objAddon,
					position:"bottom"
			});
			
		});
		
		
		return(arrPositions);
	}
	
	/**
	 * get closest placeholder position
	 */
	function getClosestPlaceholderPosition(){
		
		if(!g_temp.current_col_id)
			return(null);
		
		var arrPositions = g_ucAdmin.getVal(g_temp.placeholder_positions, g_temp.current_col_id);
		
		if(!arrPositions || arrPositions.length == 0)
			return(null);
				
		var minDistance = 10000;
		var closestIndex = null;
				
		for(var index in arrPositions){
			var objPos = arrPositions[index];
						
			var distance = Math.abs(objPos.posy - g_temp.grid_mouse_y);
			
			if(distance < minDistance){
				minDistance = distance;
				closestIndex = index;
			}
		}
		
		
		var objPos = arrPositions[closestIndex];
		
		return(objPos);
	}
	
	
	/**
	 * check if the element is dragging placeholder
	 */
	function isElementDraggingPlaceholder(objElement){
		
		if(!objElement)
			return(false);
		
		//if it's active drag source
		if(objElement.hasClass(g_vars.class_dragging_placeholder))
			return(true);
				
		return(false);
	}
	
		
	
	/**
	 * put active placeholder div before or after addon
	 */
	function putActivePlaceholderDiv(objAddon, position){
		
		if(!objAddon)
			return(false);
				
		var html = "<div class='"+g_vars.class_dragging_placeholder+"'></div>";
		
		//get next or prev element
		if(position == "bottom")
			var objNextElement = objAddon.next();
		else
			var objNextElement = objAddon.prev();
				
		//check if ther placeholder is already exists
		var isPlaceholder = isElementDraggingPlaceholder(objNextElement);
		
		if(isPlaceholder == true)
			return(false);
		
		removeAllPlaceholders();
				
		if(position == "bottom")
			objAddon.after(html);
		else
			objAddon.before(html);
		
	}
	
	
	/**
	 * check if current col is empty, no addons in it
	 */
	function isCurrentColEmpty(){
		
		if(!g_temp.current_col)
			return(false);
		
		var isEmpty = g_temp.current_col.hasClass(g_objGrid.g_vars.class_empty);
		
		return(isEmpty);
	}
	
	
	/**
	 * calculate the closest placeholder index inside the column
	 */
	function putColPlaceholderIndex(){
		
		//check empty element placeholder
		var isColEmpty = isCurrentColEmpty();
		if(isColEmpty == true){
			removeAllPlaceholders();
			return(false);
		}
		
		//get current placeholder position
		var objPos = getClosestPlaceholderPosition();
		if(!objPos)
			return(false);
		
		putActivePlaceholderDiv(objPos.addon, objPos.position);
	}
	
	
	/**
	 * on drag mouse move
	 */
	function onDragMouseMove(){
		
		var objCol = operateMouseColumn();
		
		if(objCol){
			var colID = objCol.prop("id");
			showDebug(colID);
			
		}else{
			showDebug("no col");
		}
				
		putColPlaceholderIndex(objCol);
		
		positionDraggingObject();
	}
	
	
	
	function ____________EVENTS______________(){}
	
	
	/**
	 * on document mouse up
	 */
	function onDocumentMouseUp(){
				
		if(g_temp.is_drag_mode == true)
			stopDragMode();
				
	}
	
	/**
	 * on handle mouse down - start the drag
	 */
	function onAddonHandleMouseDown(event){
		
		var objHandle = jQuery(this);
		var objAddon = g_objGrid.getParentAddonElement(objHandle);
		
		saveFrameOffsets();
		saveParentMousePos(event);
		
		startDragMode(objAddon);
		
	}
	
	
		
	
	/**
	 * on parent mouse move
	 */
	function onParentMouseMove(event){
		
		if(g_temp.is_drag_mode == false)
			return(true);
		
		//set page fixed positions
		g_temp.page_mouse_x = event.pageX;
		g_temp.page_mouse_y = event.pageY;
		
		//set grid absolute positions
		g_temp.grid_mouse_y = g_temp.page_mouse_y - g_temp.frame_offset_y + g_temp.body_offset_y;
		g_temp.grid_mouse_x = g_temp.page_mouse_x - g_temp.frame_offset_x + g_temp.body_offset_x;
		
		onDragMouseMove();
	}
	
	
	/**
	 * frame mouse move
	 */
	function onFrameMouseMove(event){
		
		if(g_temp.is_drag_mode == false)
			return(true);
		
		saveParentMousePos(event);
		
		g_temp.grid_mouse_x = event.clientX;
		g_temp.grid_mouse_y = event.clientY;
						
		onDragMouseMove();
	}
	
	
	/**
	 * init events
	 */
	function initEvents(){
				
		g_objGridWrapper.on("mousedown",".uc-addon-icon-move", onAddonHandleMouseDown);
		
		var objFrameWindow = jQuery(window);
		
		objFrameWindow.on("mousemove", onFrameMouseMove);
		g_objBodyParent.on("mousemove", onParentMouseMove);
		
		objFrameWindow.on("mouseup", stopDragMode);
		g_objBodyParent.on("mouseup", stopDragMode);
		
	}
	
	
	/**
	 * init the grid data
	 */
	this.init = function(objGrid){
				
		g_objGrid = objGrid;
		
		g_objBodyParent = g_objGrid.g_objBodyParent;
		
		if(!g_objBodyParent)
			return(false);
		
		g_objGridWrapper = objGrid.g_objGrid;
		
		g_objBuilderWrapper = objGrid.g_objPageBuilderWrapper;
				
		g_objDraggingObject = g_objBuilderWrapper.find(".uc-grid-dragging-object");
		
		g_objIframe = g_objGrid.g_pageBuilder.getIframe();
		
		g_objTempIndicator = jQuery("#uc_test_absolute_indicator");
		if(g_objTempIndicator.length == 0)
			g_objTempIndicator = null;
		
		initEvents();
				
	}
	
}
