
function UniteCreatorGridBuilder_gridData(){
	
	var g_objGrid; //for the autocomplete
	var t = this;
	
	if (!g_ucAdmin)
		var g_ucAdmin = new UniteAdminUC();
	
	
	this.____________________GET_DATA________________ = function() {}

	/**
	 * modify addon data before save remove everything except the real data
	 */
	this.modifyAddonDataBeforeSave = function(addonData, removeOutputOnly) {
		
		if (!addonData)
			return (null);

		var arrDeleteFields = [ "output", "extra" ];
		if (removeOutputOnly === true)
			arrDeleteFields = [ "output" ];

		var addonDataOutput = {};

		jQuery.each(addonData, function(key, value) {

			if (arrDeleteFields.indexOf(key) == -1)
				addonDataOutput[key] = addonData[key];
		});

		return (addonDataOutput);
	}
	
	
	/**
	 * modify addon data before copy
	 */
	this.modifyAddonDataBeforeCopy = function(addonData) {
		
		return t.modifyAddonDataBeforeSave(addonData, true);
	}
	
	
	/**
	 * modify element settings before get
	 */
	this.getGridData_modifySettings = function(settings, forCopy, modifyFunc) {
		
		if (!settings)
			return (settings);

		var addonData = g_ucAdmin.getVal(settings, "bg_addon_single_data");
		if (!addonData)
			return (settings);

		// set modify func
		if (!modifyFunc) {
			if (forCopy === true)
				var modifyFunc = t.modifyAddonDataBeforeCopy;
			else
				var modifyFunc = t.modifyAddonDataBeforeSave;
		}

		addonData = modifyFunc(addonData);
		settings["bg_addon_single_data"] = addonData;

		return (settings);
	}

	/**
	 * get col addon data
	 */
	this.getColAddonData = function(objAddon, funcModify) {
		
		g_objGrid.validateColAddonElement(objAddon);
		
		var addonID = objAddon.prop("id");
		
		var objData = objAddon.data("addon_data");
		
		var options = objAddon.data("addon_settings");
		if (options) {
			if (!objData)
				objData = {};
			
			objData.options = t.getGridData_modifySettings(options, null,funcModify);
		}

		// set options
		if (!objData)
			objData = null;

		// make it not a link
		var objDataOutput = jQuery.extend({}, objData);
		objDataOutput.id = addonID;
		
		if (funcModify && typeof funcModify == "function") {
			var returnData = funcModify(objDataOutput);
			return (returnData);
		}

		return (objDataOutput);
	}

	/**
	 * get col addons data
	 */
	this.getColAddonsData = function(objCol, funcModify) {

		var objAddons = g_objGrid.getColAddons(objCol);

		var arrData = [];

		jQuery.each(objAddons, function(index, addon) {
			var objAddon = jQuery(addon);
			var objData = t.getColAddonData(objAddon, funcModify);
			
			objData.type = "addon";
			
			arrData.push(objData);
		});

		return (arrData);
	}
	
	
	/**
	 * get columns data
	 */
	this.getGridData_cols = function(objRow, forCopy) {
		
		var objContainer = g_objGrid.getRowContainer(objRow);

		var objCols = g_objGrid.getCols(objContainer);
		var dataCols = [];

		if (forCopy === true)
			var modifyFunc = t.modifyAddonDataBeforeCopy;
		else
			var modifyFunc = t.modifyAddonDataBeforeSave;

		// create col data
		jQuery.each(objCols, function(colIndex, col) {
			
			var objCol = jQuery(col);
			
			var colID = objCol.prop("id");
			
			var dataCol = {};
			dataCol.id = colID;
			dataCol.addon_data = t.getColAddonsData(objCol, modifyFunc);
			
			var colSettings = objCol.data("settings");
			if (colSettings)
				dataCol.settings = t.getGridData_modifySettings(colSettings,
						forCopy);

			var size = g_objGrid.getColSize(objCol);
			if (size)
				dataCol.size = size;
			
			dataCol.type = "col";
			
			dataCols.push(dataCol);
		});

		return (dataCols);
	}

	/**
	 * get containers columns data
	 */
	this.getGridData_containers = function(objRow, forCopy) {
		
		var dataContainers = [];
		var objContainers = g_objGrid.getRowContainersAll(objRow);
		
		// create col data
		jQuery.each(objContainers, function(containerIndex, container) {
			
			var objContainer = jQuery(container);
			var containerID = objContainer.prop("id");
			
			var dataContainer = {};
			dataContainer.id = containerID;
			dataContainer.cols = t.getGridData_cols(objContainer, forCopy);
			
			var containerSettings = objContainer.data("settings");
			if (containerSettings)
				dataContainer.settings = t.getGridData_modifySettings(containerSettings, forCopy);
			
			dataContainer.type = "container";
			
			dataContainers.push(dataContainer);
		});

		return (dataContainers);
	}

	/**
	 * get row data forCopy - yes/no
	 */
	this.getGridData_row = function(objRow, forCopy, forSingleSave) {

		var dataRow = {};
		
		//add row id
		var rowID = objRow.prop("id");
		dataRow.id = rowID;
		
		//add containers
		var objContainers = g_objGrid.getRowContainersAll(objRow);
		dataRow.containers = t.getGridData_containers(objRow, forCopy);

		//add settings
		var rowSettings = objRow.data("settings");
		
		if (rowSettings)
			dataRow.settings = t.getGridData_modifySettings(rowSettings, forCopy);
		
		dataRow.type = "row";
		
		if (forSingleSave === true) {
			var dataGrid = {};
			dataGrid.rows = [ dataRow ];
			return (dataGrid);
		}
		
		return (dataRow);
	}

	
	/**
	 * get grid rows
	 */
	this.getGridData_rows = function(){

		var dataRows = [];
		var objRows = g_objGrid.getRows();

		jQuery.each(objRows, function(index, row) {
			var objRow = jQuery(row);
			var dataRow = t.getGridData_row(objRow);

			dataRows.push(dataRow);

		});

		return (dataRows);
	}

	
	
	/**
	 * init the grid data
	 */
	this.init = function(objGrid){
		g_objGrid = objGrid;
	}
	
}
