<?php
/**
 * @package Blox Page Builder
 * @author UniteCMS.net
 * @copyright (C) 2017 Unite CMS, All Rights Reserved. 
 * @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 * */
defined('_JEXEC') or die('Restricted access');

class UniteCreatorDialogParam extends UniteCreatorDialogParamWork{
	
	const PARAM_JOOMLA_MODULE = "uc_joomla_module";
	const PARAM_JOOMLA_K2_ITEM = "uc_joomla_k2_item";
	
	
	/**
	 * put param content
	 */
	protected function putParamFields($paramType){
		
		switch($paramType){
			case self::PARAM_POST:
				$this->putNoDefaultValueText();
				break;
			case self::PARAM_JOOMLA_MODULE:
				$this->putNoDefaultValueText();
			break;
			case self::PARAM_JOOMLA_K2_ITEM:
				$this->putNoDefaultValueText();
			break;
			default:
				parent::putParamFields($paramType);
			break;
		}
	}
	
	/**
	 * init main params, add platform related param
	 */
	public function initMainParams(){
		
		parent::initMainParams();
		
		$this->arrParams[] = self::PARAM_MAP;
		$this->arrParams[] = self::PARAM_FORM;
		
		$this->arrParams[] = self::PARAM_POST;
		$this->arrParams[] = self::PARAM_JOOMLA_MODULE;
		$this->arrParams[] = self::PARAM_JOOMLA_K2_ITEM;
		$this->arrParams[] = self::PARAM_CONTENT;
		$this->arrParams[] = self::PARAM_POSTS_LIST;
		
		$this->arrParams = UniteProviderFunctionsUC::applyFilters(UniteCreatorFilters::FILTER_PARAMS_DIALOG_MAIN_PARAMS, $this->arrParams);
	}
	
	
	/**
	 * init param types
	 */
	protected function initParamTypes(){
		parent::initParamTypes();
		
		$this->addParam(self::PARAM_JOOMLA_MODULE , __("Module", BLOXBUILDER_TEXTDOMAIN));
		$this->addParam(self::PARAM_JOOMLA_K2_ITEM , __("K2 Item", BLOXBUILDER_TEXTDOMAIN));
		
	}
	
	
	/**
	 * modify param text, function for override
	 */
	protected function modifyParamText($paramType, $paramText){
		
		switch($paramType){
			case self::PARAM_POST:
				$paramText = __("Article", BLOXBUILDER_TEXTDOMAIN);
			break;
			case self::PARAM_POSTS_LIST:
				$paramText = __("Articles List", BLOXBUILDER_TEXTDOMAIN);
			break;
		}
		
		return($paramText);
	}
	
	
}