<?php
/**
 * @package Blox Page Builder
 * @author UniteCMS.net
 * @copyright (C) 2017 Unite CMS, All Rights Reserved. 
 * @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 * */
defined('_JEXEC') or die('Restricted access');

class UniteCreatorSettings extends UniteCreatorSettingsWork{
	
	const TYPE_MODULE = "joomla_module";
	const TYPE_JOOMLA_K2_ITEM = "joomla_k2_item";
	
	
	/**
	 * get settings types array
	 */
	public function getArrUCSettingTypes(){
		
		$arrTypes = parent::getArrUCSettingTypes();
		
		if(UniteProviderFunctionsUC::$isStandAlone == true)
			return($arrTypes);
		
		$arrTypes[] = UniteCreatorDialogParam::PARAM_JOOMLA_MODULE;
		$arrTypes[] = UniteCreatorDialogParam::PARAM_JOOMLA_K2_ITEM;
		
		
		return($arrTypes);
	}
	
	
	/**
	 * add module picker
	 */
	public function addModulePicker($name,$defaultValue = "",$text = "",$arrParams = array()){
		$this->add($name,$defaultValue,$text,self::TYPE_MODULE, $arrParams);
	}
	
	
	/**
	 * add module picker
	 */
	public function addK2ItemPicker($name,$defaultValue = "",$text = "",$arrParams = array()){
		$this->add($name,$defaultValue,$text,self::TYPE_JOOMLA_K2_ITEM, $arrParams);
	}
	
	private function a____POSTS_LIST____(){} 
	
	
	/**
	 * add post list picker
	 */
	protected function addPostsListPicker($name,$value,$title,$extra){
	    
		$arrDir = array("Asc"=>"asc", "Desc"=>"desc");
		
		$arrCats = UniteFunctionJoomlaUC::getArrCategoriesShort();
		$category = UniteFunctionsUC::getVal($value, $name."_category");
		$this->addSelect($name."_category", $arrCats, __("Article Category", BLOXBUILDER_TEXTDOMAIN), $category);
		
		$params = array("unit"=>"articles");
		$maxItems = UniteFunctionsUC::getVal($value, $name."_maxitems", 10);
		$this->addTextBox($name."_maxitems", $maxItems, __("Max Articles", BLOXBUILDER_TEXTDOMAIN), $params);
		
		//orderby1
		$arrOrder = UniteFunctionJoomlaUC::getArticlesOrderby();
		$params = array();
		$params[UniteSettingsUC::PARAM_ADDFIELD] = $name."_orderdir1";
		$orderBY = UniteFunctionsUC::getVal($value, $name."_orderby", "ordering");
		
		$this->addSelect($name."_orderby", $arrOrder, __("Order By", BLOXBUILDER_TEXTDOMAIN), $orderBY, $params);
		
		$orderDir1 = UniteFunctionsUC::getVal($value, $name."_orderdir1", "asc");
		$this->addSelect($name."_orderdir1", $arrDir, self::PARAM_NOTEXT, $orderDir1);
		
		//orderby2
		$arrOrder2 = UniteFunctionJoomlaUC::getArticlesOrderby(true);
		$params[UniteSettingsUC::PARAM_ADDFIELD] = $name."_orderdir2";
		
		$orderBY2 = UniteFunctionsUC::getVal($value, $name."_orderby2", "");
		$this->addSelect($name."_orderby2", $arrOrder2, __("Second Order By (optional)", BLOXBUILDER_TEXTDOMAIN), $orderBY2, $params);
		
		$orderDir2 = UniteFunctionsUC::getVal($value, $name."_orderdir2", "asc");
		$this->addSelect($name."_orderdir2", $arrDir, self::PARAM_NOTEXT, $orderDir2);
		
		$this->addHr();
		
	}
	
	
	/**
	 * add menu picker
	 */
	protected function addMenuPicker($name,$value,$title,$extra){
		
		$arrMenus = UniteFunctionJoomlaUC::getArrMenus();
		$firstMenu = UniteFunctionsUC::getFirstNotEmptyKey($arrMenus);
		$arrMenus = array_flip($arrMenus);
		
		$menutype = UniteFunctionsUC::getVal($value, $name."_menutype", $firstMenu);
		
		$this->addSelect($name."_menutype", $arrMenus, __("Select Menu", BLOXBUILDER_TEXTDOMAIN), $menutype);
		
		$this->addRadioBoolean($name."_show_submenu", __("Show Sub Menu Items",BLOXBUILDER_TEXTDOMAIN) );
		
		$this->addHr();
	}
	
	
	private function a____CONTENT_SELECTOR____(){} 
	
	/**
	 * add settings provider types
	 */
	protected function addSettingsProvider($type, $name,$value,$title,$extra ){
		
		switch ($type){
			case UniteCreatorDialogParam::PARAM_JOOMLA_MODULE:
				$this->addModulePicker($name,$value,$title,$extra);
				break;
			case UniteCreatorDialogParam::PARAM_JOOMLA_K2_ITEM:
				$this->addK2ItemPicker($name,$value,$title,$extra);
				break;
			default:
				return(false);
			break;
		}
	
		return(true);
	}
	
	
	/**
	 * add content selector options
	 */
	protected function addContentSelectorOptions($arrOptions, $name){
		
		$arrOptions[__("Article", BLOXBUILDER_TEXTDOMAIN)] = "post";
		
		if(UniteFunctionJoomlaUC::isK2Exists() == true)
		  $arrOptions[__("K2 Item", BLOXBUILDER_TEXTDOMAIN)] = "k2item";
		
		  $arrOptions[__("Module", BLOXBUILDER_TEXTDOMAIN)] = "module";
		  
		  
		return($arrOptions);	
	}
	
	
	/**
	 * add content selector fields, function for override
	 */
	protected function addContentSelectorField($option, $name, $arrDefaultValues){
		
		switch($option){
			case "post":
			    
			    $value = UniteFunctionsUC::getVal($arrDefaultValues, $name."_postid");
			    
			    $this->addPostPicker($name."_postid", $value, "&nbsp;".__("Select Article", BLOXBUILDER_TEXTDOMAIN));
			break;
			case "k2item":
			    $value = UniteFunctionsUC::getVal($arrDefaultValues, $name."_k2item");
			    
			    $this->addK2ItemPicker($name."_k2item",$value, "&nbsp;".__("Select K2 Item", BLOXBUILDER_TEXTDOMAIN));
			break;
			case "module":
			    $value = UniteFunctionsUC::getVal($arrDefaultValues, $name."_moduleid");
			    
			    $this->addModulePicker($name."_moduleid",$value,"&nbsp;".__("Choose Module", BLOXBUILDER_TEXTDOMAIN));
			break;
			default:
				UniteFunctionsUC::throwError("addContentSelectorField error: Wrong option: $option");
			break;
		}
		
	}
		
	
}