<?php
/**
 * @package Blox Page Builder
 * @author UniteCMS.net
 * @copyright (C) 2017 Unite CMS, All Rights Reserved. 
 * @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 * */
defined('_JEXEC') or die('Restricted access');


class UniteCreatorAddonViewProvider extends UniteCreatorAddonView{
	
	private $addonID_provider;
	private $addonType_provider;
	
	
	/**
	 * add update button
	 */
	private function addToolbar_update(){
		
		$textUpdate = __("Update", BLOXBUILDER_TEXTDOMAIN);
		$textUpdating = __("Updating...", BLOXBUILDER_TEXTDOMAIN);
		
		$html = "";
		$html .= '<span class="uc-toolbar-save-wrapper">';
		$html .= '<a id="button_update_addon" class="button_update_addon unite-button-primary" href="javascript:void(0)">'.$textUpdate.'</a>';
		$html .= '<div style="padding-top:6px;">';
		$html .= '<span id="uc_loader_update" class="loader_text" style="display:none">'.$textUpdating.'</span>';
		$html .= '<span id="uc_message_addon_updated" class="unite-color-green" style="display:none"></span>';
		$html .= '</div>';
		$html .= '</span>';
		
		$bar = JToolbar::getInstance('toolbar');
		$bar->appendButton('Custom', $html, "update_addon");
		
	}
	
	
	/**
	 * add back button
	 */
	private function addToolbar_back(){
		
		$urlBack = HelperUC::getViewUrl_Addons($this->addonType_provider);
		$textBack = __("Back to Addons List", BLOXBUILDER_TEXTDOMAIN);
		
		$html = "";
		$html .= '<a class="unite-button-secondary" href="'.$urlBack.'">'.$textBack.'</a>';
		$html .= '<span class="uc-toolbar-sap"></span>';

		$bar = JToolbar::getInstance('toolbar');
		$bar->appendButton('Custom', $html, "back_button");
		
		return($html);
	}
	
	/**
	 * test addon
	 */
	private function addToolbar_addonDefaultContent(){
		
		$urlEditDefaults = HelperUC::getViewUrl_AddonDefaults($this->addonID_provider);
		
		$text = __("Addon Defaults", BLOXBUILDER_TEXTDOMAIN);
		
		$html = "";
		$html .= '<a href="'.$urlEditDefaults.'" class="unite-button-secondary " >'.$text.'</a>';
		$html .= '<span class="uc-toolbar-sap"></span>';
		
		
		$bar = JToolbar::getInstance('toolbar');
		$bar->appendButton('Custom', $html, "addon_defaults");
		
		return($html);
	}
	
	
	/**
	 * test addon
	 */
	private function addToolbar_testAddon(){
		
		$urlTestAddon = HelperUC::getViewUrl_TestAddon($this->addonID_provider);
		
		$textTestAddon = __("Test Addon", BLOXBUILDER_TEXTDOMAIN);
		
		$html = "";
		$html .= '<a href="'.$urlTestAddon.'" class="unite-button-secondary " >'.$textTestAddon.'</a>';
		$html .= '<span class="uc-toolbar-sap"></span>';
		
		
		$bar = JToolbar::getInstance('toolbar');
		$bar->appendButton('Custom', $html, "test_addon");
		
		return($html);
	}
	
	
	/**
	 * preview addon
	 */
	private function addToolbar_previewAddon(){
		
		$urlPreviewAddon = HelperUC::getViewUrl_TestAddon($this->addonID_provider, "preview=1");
		
		$textPreview = __("Preview Addon", BLOXBUILDER_TEXTDOMAIN);
		
		$html = "";
		$html .= '<a href="'.$urlPreviewAddon.'" class="unite-button-secondary " >'.$textPreview.'</a>';
		$html .= '<span class="uc-toolbar-sap"></span>';

		$bar = JToolbar::getInstance('toolbar');
		$bar->appendButton('Custom', $html, "test_addon");
		
		return($html);
	}
	
	
	/**
	 * preview addon
	 */
	private function addToolbar_exportAddon(){
				
		$textExport = __("Export Addon", BLOXBUILDER_TEXTDOMAIN);
		
		$html = "";
		$html .= '<a id="button_export_addon" href="javascript:void(0)" class="unite-button-secondary " >'.$textExport.'</a>';
		$html .= '<span class="uc-toolbar-sap"></span>';
		
		$bar = JToolbar::getInstance('toolbar');
		$bar->appendButton('Custom', $html, "export_addon_edit");
		
		return($html);
	}
	
	
	/**
	 * update addon from catalog version
	 */
	private function addToolbar_updateFromCatalog(){
				
		$textUpdate = __("Update From Catalog", BLOXBUILDER_TEXTDOMAIN);
		$textUpdating = __("Updating...", BLOXBUILDER_TEXTDOMAIN);
				
		$html = "";
		$html .= '<span class="uc-toolbar-save-wrapper">';
		$html .= '<a id="uc_button_update_catalog" class="button_update_addon unite-button-secondary" href="javascript:void(0)">'.$textUpdate.'</a>';
		$html .= '<div style="padding-top:6px;">';
		$html .= '<span id="uc_loader_update_catalog" class="loader_text" style="display:none">'.$textUpdating.'</span>';
		$html .= '<span id="uc_message_addon_updated_catalog" class="unite-color-green" style="display:none"></span>';
		$html .= '</div>';
		$html .= '</span>';
		
		$bar = JToolbar::getInstance('toolbar');
		$bar->appendButton('Custom', $html, "update_addon");
				
		return($html);
	}
	
	
	/**
	 * add joomla toolbar
	 */
	private function addToolbar(){
		
		$isShowPreviewTest = true;
		if($this->isSVG == true)
			$isShowPreviewTest = false;
		
		
		$this->addonID_provider = $this->objAddon->getID();
		$this->addonType_provider = $this->objAddon->getType();
		
		$this->addToolbar_update();
		$this->addToolbar_back();
		
		if($isShowPreviewTest == true){
			$this->addToolbar_testAddon();
			$this->addToolbar_addonDefaultContent();
			$this->addToolbar_previewAddon();
		}
		
		$this->addToolbar_exportAddon();
			
		$isExistsInCatalog = $this->objAddon->isExistsInCatalog();
				
		if($isExistsInCatalog == true)
			$this->addToolbar_updateFromCatalog();
		
	}
	
	
	/**
	 * set header text
	 */
	private function setJoomlaHeaderText(){
		
		$title = $this->getHeaderTitle();
		
		HelperProviderUC::setToolbarTitle($title);
	}
	
	
	/**
	 * get k2 item child keys
	 */
	protected function getChildKeys_k2Item(){
		
		$arrParams = array();
		
		$arrParams[] = $this->createChildParam("id");
		$arrParams[] = $this->createChildParam("title");
		$arrParams[] = $this->createChildParam("content", UniteCreatorDialogParam::PARAM_EDITOR);
		$arrParams[] = $this->createChildParam("intro", UniteCreatorDialogParam::PARAM_EDITOR);
		$arrParams[] = $this->createChildParam("image");
		$arrParams[] = $this->createChildParam("thumb");
		
		return($arrParams);
	}
	
	
	/**
	 * get params child keys
	 */
	protected function getParamChildKeys(){
		
		$arrChildKeys = parent::getParamChildKeys();
		
		$arrChildKeys[UniteCreatorDialogParam::PARAM_JOOMLA_K2_ITEM] = $this->getChildKeys_k2Item();
		
		return($arrChildKeys);
	}

	
	/**
	 * constructor
	 */
	public function __construct(){
				
		if(UniteProviderFunctionsUC::$isStandAlone == false){
			
			$this->showHeader = false;
			$this->showToolbar = false;
		}
		
		parent::__construct();

		if(UniteProviderFunctionsUC::$isStandAlone == false){
			$this->addToolbar();
			$this->setJoomlaHeaderText();
		}
		
	}
	
}