<?php
/**
 * @package Blox Page Builder
 * @author UniteCMS.net
 * @copyright (C) 2017 Unite CMS, All Rights Reserved. 
 * @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 * */
defined('_JEXEC') or die('Restricted access');


class UniteCreatorLibraryViewProvider extends UniteCreatorLibraryView{
	
	
	
	/**
	 * preview addon
	 */
	private function addToolbar_layoutsLink(){
		
		$urlLayouts = HelperUC::getViewUrl_LayoutsList();
		
		$textLayouts = HelperUC::getText("my_layouts");
		
		$html = "";
		$html .= '<a href="'.$urlLayouts.'" class="unite-button-secondary " >'.$textLayouts.'</a>';
		$html .= '<span class="uc-toolbar-sap"></span>';
		
		$bar = JToolbar::getInstance('toolbar');
		$bar->appendButton('Custom', $html, "link_layouts");
		
		return($html);
	}
	
	
	
	
	/**
	 * add joomla toolbar
	 */
	private function addToolbar(){
		
		HelperProviderUC::addToolbar_layoutsLink();
		//HelperProviderUC::addToolbar_templatesLink(false);
		
		UniteProviderFunctionsUC::doAction(UniteCreatorFilters::ACTION_ADD_ADDONS_TOOLBAR_BUTTON);
		
	}
	
	
	/**
	 * set header text
	 */
	private function setJoomlaHeaderText(){
		
		$title = $this->getHeaderText();
		
		HelperProviderUC::setToolbarTitle($title);
	}
	
	
	
	/**
	 * constructor
	 */
	public function __construct(){
		
		if(UniteProviderFunctionsUC::$isStandAlone == true){
			parent::__construct();
			return(false);
		}
		
		$this->showButtons = false;
		$this->showHeader = false;
		
		parent::__construct();
		
		$this->setJoomlaHeaderText();
		$this->addToolbar();
		
	}
	
}