<?php

/**
 * media manager view
 *
 */
class UniteCreatorViewMediaManager{
	
	public $showHeader = true;
	public $showButtons = true;
	
	
	/**
	 * get headre text
	 */
	protected function getHeaderText(){
		
		$headerTitle = __("Manage Media", BLOXBUILDER_TEXTDOMAIN);
		
		return($headerTitle);
	}
	
	
	/**
	 * put header
	 */
	protected function putHtmlHeader(){
		
		if($this->showHeader == true){
			
			$headerTitle = $this->getHeaderText();
			
			require HelperUC::getPathTemplate("header");
		}else
			require HelperUC::getPathTemplate("header_missing");
		
	}
	
		
	/**
	 * show buttons panel
	 */
	protected function putHtmlButtonsPanel(){
		
		$urlLayouts = HelperUC::getViewUrl_LayoutsList();
		$urlAddons = HelperUC::getViewUrl_Addons();
		$urlLirary = HelperUC::getViewUrl(GlobalsUC::VIEW_LIBRARY);
		
		?>
		<div class="uc-buttons-panel unite-clearfix">
			<a href="<?php echo $urlLayouts?>" class="unite-float-right mleft_20 unite-button-secondary"><?php HelperUC::putText("my_layouts")?></a>
			<a href="<?php echo $urlAddons?>" class="unite-float-right mleft_20 unite-button-secondary"><?php _e("My Addons", BLOXBUILDER_TEXTDOMAIN)?></a>
			<a href="<?php echo $urlLirary?>" class="unite-float-right mleft_20 unite-button-secondary"><?php _e("My Library", BLOXBUILDER_TEXTDOMAIN)?></a>
			
		</div>
		
		<?php 
	}
	
	
	/**
	 * put html
	 */
	public function putHtml(){
		
		$this->putHtmlHeader();
		
		if($this->showButtons == true)
			$this->putHtmlButtonsPanel();

		?>
		
		<div class="content_wrapper unite-content-wrapper">
			
		
		<?php 
		
		
		$action = UniteFunctionsUC::getGetVar("action","",UniteFunctionsUC::SANITIZE_KEY);
		$pathElfinder = GlobalsUC::$pathProvider."elfinder/";
		$urlElfinder = GlobalsUC::$url_provider."elfinder/";
		
		if($action == "connector"){
			require $pathElfinder."php/connector.minimal.php";
			runElfinderConnector();
			exit();
		}
		
		$path = UniteFunctionsUC::getGetVar("path","",UniteFunctionsUC::SANITIZE_NOTHING);
		$filetype = UniteFunctionsUC::getGetVar("filetype","",UniteFunctionsUC::SANITIZE_KEY);
		
		
		//set add url for the connector
		$addUrl = "";
		if(!empty($path))
			$addUrl = "&path=".$path;
		
		//$urlBase 
		$urlBase = $urlElfinder;
		
		$mime = "image";
		
		$urlConnector = HelperUC::getViewUrl("mediaselect", "action=connector");
		$urlConnector .= $addUrl;
		
		
		?>
<div id="finder"><?php _e("Loading Media Select...", BLOXBUILDER_TEXTDOMAIN)?></div>
		
	<script type="text/javascript">

		//return true if some dir selected
		function isDirSelected(arrFiles){
			for(var index in arrFiles){
				var file = arrFiles[index];
				if(file.mime == "directory")
					return(true);
			}
			
			return(false);
		}

		//get url's array from files 
		function getArrUrls(selectedFiles){
			var arrUrls = [];
			for(var index in selectedFiles){
				var file = selectedFiles[index];
				var hash = file["hash"];
				var url = g_finder.url(hash);
				var path = g_finder.path(hash);
				arrUrls.push({url: url, path: path});
			}
			
			return(arrUrls);
		}
		
		var g_finder = null;
		
		$(document).ready(function() {
			node = $('#finder').elfinder({
				url : "<?php echo $urlConnector?>",
				handlers : {
					init:function(event, elfinderInstance){
						g_finder = elfinderInstance;
					}
					
                },
				onlyMimes : ['<?php echo $mime?>'],
				requestType : 'POST',
				rememberLastDir : true,
				commands : ['reload', 'up','getfile', 
				            'quicklook', 'download',"rm", 'duplicate', 'rename', 'mkdir', 'upload', 'copy', 
						    'cut', 'paste', 'search', 'info', 'view', 'resize', 'sort'],
                
                getfile : {
                    onlyURL  : false,
                    multiple : true,
                    folders  : false,
                    oncomplete : 'close'
                },
                
                uiOptions : {
                    // toolbar configuration
                    toolbar : [
                        ['help'],
                        ['view'],
                        ['mkdir', 'mkfile'],
                        ['open', 'download'],
                        ['info'],
                        ['quicklook'],
                        ['copy', 'cut', 'paste'],
                        ['duplicate', 'rename', 'edit', 'resize'],
                        ['rm'],
                        ['upload'],
                        ['search'],
                    ],
                },
                
                contextmenu : {

                    cwd    : ['upload', '|' , 'reload', 'back', '|', 'mkdir', 'mkfile', 'paste', '|', 'info'],

                 },
                
			});

			   
		});
		
		
	</script>
	
		</div>
	
		<?php 
		
	}
	
	
}


$objViewMediaManager = new UniteCreatorViewMediaManager();
$objViewMediaManager->putHtml();


