<?php
/**
 * @package Blox Page Builder
 * @author UniteCMS.net
 * @copyright (C) 2017 Unite CMS, All Rights Reserved. 
 * @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 * */
defined('_JEXEC') or die('Restricted access');


class UniteCreatorLayoutsViewProvider extends UniteCreatorLayoutsView{

	
	/**
	* new layout add
	 */
	private function addToolbar_newLayout(){
		
		$text = HelperUC::getText("new_layout");
		
		if($this->isTemplate == false)
			$urlViewCreateObject = HelperUC::getViewUrl_Layout(null, "", $this->layoutType);
		else
			$urlViewCreateObject = HelperUC::getViewUrl_Template(null, $this->layoutType);
		
		
		$html = "";
		$html .= "<a href=\"{$urlViewCreateObject}\" class=\"unite-button-primary unite-float-left\">{$text}</a>";
		
		$bar = JToolbar::getInstance('toolbar');
		$bar->appendButton('Custom', $html, "new_layout");
	}
	
	
	/**
	 * new layout add
	 */
	private function addToolbar_importLayout(){
	
		$text = HelperUC::getText("import_layout");
		
		$html = "";
		$html .= "<a id=\"uc_button_import_layout\" href=\"javascript:void(0)\" class=\"unite-button-secondary unite-float-left mleft_20\">{$text}</a>";
		
		$bar = JToolbar::getInstance('toolbar');
		$bar->appendButton('Custom', $html, "new_layout");
	}
	
	/**
	 * add import page from catalog button
	 */
	private function addToolbar_importLayoutFromCatalog(){
		
		$text = __("My Pages Catalog", BLOXBUILDER_TEXTDOMAIN);
		
		$html = "";
		$html .= "<a id=\"uc_button_import_layout_from_catalog\" href=\"javascript:void(0)\" class=\"unite-button-secondary unite-float-left mleft_20\">{$text}</a>";
		
		$bar = JToolbar::getInstance('toolbar');
		$bar->appendButton('Custom', $html, "new_layout");
		
	}
	
	/**
	 * new layout add
	 */
	private function addToolbar_globalSettings(){
		
		$text = HelperUC::getText("layouts_global_settings");
	
		$html = "";
		$html .= "<a href=\"javascript:void(0)\" id=\"uc_layouts_global_settings\" class=\"unite-float-right mright_20 unite-button-secondary\">{$text}</a>";
		
		$bar = JToolbar::getInstance('toolbar');
		$bar->appendButton('Custom', $html, "global_settings");
	}
	
		
	/**
	 * new layout add
	 */
	private function addToolbar_managePages(){
		
		$text = __("My Pages", BLOXBUILDER_TEXTDOMAIN);
		$urlLayouts = HelperUC::getViewUrl_LayoutsList();
				
		$html = "";
		$html .= "<a href=\"{$urlLayouts}\" class=\"unite-float-right mright_20 unite-button-secondary\">{$text}</a>";
		
		$bar = JToolbar::getInstance('toolbar');
		$bar->appendButton('Custom', $html, "manage_addons");
	}
		
	
	/**
	 * add joomla toolbar
	 */
	private function addToolbar(){
		
		$this->addToolbar_newLayout();
		
		$this->addToolbar_importLayout();
		
		//add import from catalog button
		$webAPI = new UniteCreatorWebAPI();
		$isPagesCatalogExists = $webAPI->isPagesCatalogExists();
		
		if($isPagesCatalogExists == true && $this->objLayoutType->allowImportFromCatalog == true)
			$this->addToolbar_importLayoutFromCatalog();
				
		if($this->objLayoutType->isBasicType == true)
			$this->addToolbar_globalSettings();
		else{
			$this->addToolbar_managePages();
		}
		
		HelperProviderUC::addToolbar_libraryLink();
		
		UniteProviderFunctionsUC::doAction(UniteCreatorPlugins::ACTION_ADD_LAYOUTS_TOOLBAR_BUTTON);
	}
	
	
	/**
	 * set header text
	 */
	private function setJoomlaHeaderText(){
	
		$title = HelperUC::getText("my_layouts");
	
		HelperProviderUC::setToolbarTitle($title);
	}
	
	
	/**
	 * put buttons panel html
	 */
	protected function putHtmlButtonsPanel(){
		
		if(UniteProviderFunctionsUC::$isStandAlone == false){
			
			parent::putHtmlButtonsPanel();
			return(false);
		}
		
		//stand alone only
		
		?>
		<div class="uc-buttons-panel unite-clearfix">
			<a href="<?php echo $this->urlViewCreateObject?>" class="unite-button-primary unite-float-left"><?php HelperUC::putText("new_layout");?></a>
			
			<a id="uc_button_import_layout" href="javascript:void(0)" class="unite-button-secondary unite-float-left mleft_20"><?php HelperUC::putText("import_layouts");?></a>
			
			<?php if(GlobalsStandAlone::$productActivationCodeType == UniteCreatorWebAPI::ACTIVATION_TYPE_BLOX):?>
			
				<a id="uc_button_import_layout_from_catalog" href="javascript:void(0)" class="unite-button-secondary unite-float-left mleft_20"><?php _e("My Pages Catalog", BLOXBUILDER_TEXTDOMAIN)?></a>
			
			<?php endif?>
			
			<a href="javascript:void(0)" id="uc_layouts_global_settings" class="unite-float-right mright_20 unite-button-secondary"><?php HelperUC::putText("layouts_global_settings");?></a>
			<a href="<?php echo $this->urlManageAddons?>" class="unite-float-right mright_20 unite-button-secondary"><?php _e("My Addons", BLOXBUILDER_TEXTDOMAIN)?></a>
			
		</div>
		<?php 
	}
	
	
	/**
	 * constructor
	 */
	public function display(){
		
		if(UniteProviderFunctionsUC::$isStandAlone == true){
			parent::display();
			return(false);
		}
			
		$this->showButtonsPanel = false;
		$this->showHeaderTitle = false;
		
		$this->setJoomlaHeaderText();
		$this->addToolbar();
		
		parent::display();
	}
	
	
}