<?php
/**
 * @package Blox Page Builder
 * @author UniteCMS.net
 * @copyright (C) 2017 Unite CMS, All Rights Reserved. 
 * @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 * */
defined('_JEXEC') or die('Restricted access');


class UniteCreatorTestAddonViewProvider extends UniteCreatorTestAddonView{
	
	
	
	/**
	 * add edit link
	 */
	private function addToolbar_edit(){
		
		$urlEditAddon = HelperUC::getViewUrl_EditAddon($this->addonID);
		$buttonText = __("Edit This Addon", BLOXBUILDER_TEXTDOMAIN);
		
		$html = '<a href="'.$urlEditAddon.'" class="unite-button-secondary" >'.$buttonText.'</a>';
		
		UniteFunctionJoomlaUC::addToolbarCustomButton($html, "edit_addon");
	}
	
	
	/**
	* add back button
	*/
	private function addToolbar_back(){
		
		$addonType = $this->addon->getType();
		
		$text = __("Back to Addons List", BLOXBUILDER_TEXTDOMAIN);
		
		$addonsView = HelperUC::getViewUrl_Addons($addonType);
		
		$html = "<span class=\"uc-toolbar-sap\"></span>";
		$html .= '<a class="unite-button-secondary" href="'.$addonsView.'">'.$text.'</a>';
		
		UniteFunctionJoomlaUC::addToolbarCustomButton($html, "back_to_addons");
	}
	
	
	
	/**
	 * add preview buttons
	 */
	private function addToolbar_preview(){
		
		$isPreviewMode = $this->isPreviewMode;
		
		$styleShow = "";
		$styleHide = "style='display:none'";
		$textToPreview = __("To Preview", BLOXBUILDER_TEXTDOMAIN);
		$textHidePreview = __("Hide Preview", BLOXBUILDER_TEXTDOMAIN);
		$textPreviewNewTab = __("Preview New Tab", BLOXBUILDER_TEXTDOMAIN);
		
		
		$stylePreview = $isPreviewMode?$styleHide:$styleShow;
		
		$styleHidePreview = $isPreviewMode?$styleShow:$styleHide;
		
		$html = "";
		$html .= "<span class=\"uc-toolbar-sap2\"></span>";
		
		$html .= '<a id="uc_button_preview" href="javascript:void(0)" class="unite-button-secondary "'. $stylePreview.'>'.$textToPreview.'</a>';
		$html .= '<a id="uc_button_close_preview" href="javascript:void(0)" class="unite-button-secondary" '.$styleHidePreview.'>'.$textHidePreview.'</a>';
		
		$html .= "<span class=\"uc-toolbar-sap\"></span>";
		$html .= '<a id="uc_button_preview_tab" href="javascript:void(0)" class="unite-button-secondary uc-button-cat-sap">'.$textPreviewNewTab.'</a>';
		
		UniteFunctionJoomlaUC::addToolbarCustomButton($html, "preview_buttons");
	}
	
	
	/**
	 * add test addon slot
	 */
	private function addToolbar_slot1(){
				
		$slot1AddHtml = "";
		if($this->isTestData1 == false)
			$slot1AddHtml = "style='display:none'";
		
		$htmlRestore = __("Restore Data", BLOXBUILDER_TEXTDOMAIN);
		$htmlLoading = __("loading...");
		$htmlDelete = __("Delete Data", BLOXBUILDER_TEXTDOMAIN);
		$htmlDeleting = __("deleting...");
		
		
		$html = "";
		
		$html .= "<span class=\"uc-toolbar-sap3\"></span>";
		
		$html .= "<span id=\"uc_testaddon_slot1\" class=\"uc-testaddon-slot\" {$slot1AddHtml} >";
		$html .= "	<a id=\"uc_testaddon_button_restore\" href=\"javascript:void(0)\" class=\"unite-button-secondary\"> {$htmlRestore} </a>";
		$html .= "	<span id=\"uc_testaddon_loader_restore\" class=\"loader-text\" style=\"display:none\">{$htmlLoading}</span>";
		
		$html .= "	<span class=\"uc-toolbar-sap\"></span>";
		
		$html .= "	<a id=\"uc_testaddon_button_delete\" href=\"javascript:void(0)\" class=\"unite-button-secondary\">{$htmlDelete}</a>";
		$html .= "	<span id=\"uc_testaddon_loader_delete\" class=\"loader-text\" style=\"display:none\">{$htmlDeleting}</span>";

		$html .= "</span>";
		
		
		UniteFunctionJoomlaUC::addToolbarCustomButton($html, "slot1");
	}
	
	
	/**
	 * add save and clear buttons
	 */
	private function addToolbar_save_clear(){
		
		$saveData = __("Save Data", BLOXBUILDER_TEXTDOMAIN);
		$textSaving = __("saving...", BLOXBUILDER_TEXTDOMAIN);
		$textClear = __("Clear", BLOXBUILDER_TEXTDOMAIN);
		
		
		$html = "";
		$html .= "	<span class=\"uc-toolbar-sap\"></span>";
		
		$html .= "<a id=\"uc_testaddon_button_save\" href=\"javascript:void(0)\" class=\"unite-button-secondary\">{$saveData}</a>";
		$html .= "<span id=\"uc_testaddon_loader_save\" class=\"loader-text\" style=\"display:none\">{$textSaving}</span>";
		
		$html .= "	<span class=\"uc-toolbar-sap\"></span>";
		
		$html .= "<a id=\"uc_testaddon_button_clear\" href=\"javascript:void(0)\" class=\"unite-button-secondary\">{$textClear}</a>";
		
		
		UniteFunctionJoomlaUC::addToolbarCustomButton($html, "save_clear");
		
	}
	
	
	/**
	 * add joomla toolbar
	 */
	private function addToolbar(){
		
		$this->addToolbar_edit();
		$this->addToolbar_back();
		
		$this->addToolbar_preview();
		
		$this->addToolbar_slot1();
		$this->addToolbar_save_clear();
	}
	
	
	/**
	 * set header text
	 */
	private function setJoomlaHeaderText(){
		
		$title = $this->getHeader();
		
		HelperProviderUC::setToolbarTitle($title);
		
	}
	
	
	/**
	 * constructor
	 */
	public function __construct(){
		
		$this->showHeader = false;
		$this->showToolbar = false;
		
		parent::__construct();
		
		$this->setJoomlaHeaderText();
		
		$this->addToolbar();
		
	}
	
	
}