<?php
/**
 * @package		Joomla.Plugin
 * @subpackage	Content.loadmodule
 * @copyright	Copyright (C) 2005 - 2014 Open Source Matters, Inc. All rights reserved.
 * @license		GNU General Public License version 2 or later; see LICENSE.txt
 */
defined('_JEXEC') or die('Restricted access');

class plgContentBlox extends JPlugin{

	
	/**
	 * Plugin that loads module positions within content
	 *
	 * @param	string	The context of the content being passed to the plugin.
	 * @param	object	The article object.  Note $article->text is also available
	 * @param	object	The article params
	 * @param	int		The 'page' number
	 */
	public function onContentPrepare($context, &$article, &$params, $page = 0){
				
		// Don't run this plugin when the content is being indexed
		if ($context == 'com_finder.indexer')
			return true;
		
		if (strpos($article->text, '{unite_addon') === false && strpos($article->text, '{blox_page') === false)
			return true;
		
		$regex = '/{blox_page\s+(.*?)}/i';
		preg_match_all($regex, $article->text, $arrMatches, PREG_SET_ORDER);
		
		if(empty($arrMatches)){
			$regex = '/{unite_addon_layout\s+(.*?)}/i';
			preg_match_all($regex, $article->text, $arrMatches, PREG_SET_ORDER);
		}
		
		
		if(empty($arrMatches)){
			
			return(true);
		}
				
		//require gallery files.
		$pathIncludes = JPATH_ADMINISTRATOR."/components/com_blox/includes.php";
		if(!file_exists($pathIncludes))
			return(true);
				
		require_once $pathIncludes;
				
		foreach($arrMatches as $match){
			if(!isset($match[1]))
				continue;

			$arguments = $match[1];
			
			$keywords = preg_split("/\s+/", $arguments);			
			
			if(empty($keywords))
				return(true);
			
			$strLayout = $keywords[0];
			
								
			$layoutID = null;
			if(count($keywords) > 1){
				$strLayout = strtolower($strLayout);
				$strLayout = str_replace("id=", "", $strLayout);
				$strLayout = str_replace("id =", "", $strLayout);
				$strLayout = str_replace("id = ", "", $strLayout);
				$layoutID = trim($strLayout);
				$layoutID = intval($layoutID);
			}
						
			if(empty($layoutID))
				return(true);
			
			try{
				$output = HelperUC::outputLayout($layoutID, true);
				
			}catch(Exception $e){
				
				$message = "Blox Error: ".$e->getMessage();
				$output = HelperHtmlUC::getErrorMessageHtml($message);
			}
			
			//replace only first occurance
			$article->text = $article->text = preg_replace("|$match[0]|", addcslashes($output, '\\$'), $article->text, 1);
			
		}
						
		
	}
}
