<?php
/**
 * @package Blox Page Builder
 * @author UniteCMS.net
 * @copyright (C) 2017 Unite CMS, All Rights Reserved. 
 * @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 * */
defined('_JEXEC') or die('Restricted access');

$pathComponent = JPATH_ADMINISTRATOR."/components/com_blox/";
require_once $pathComponent."includes.php";

/**
 * check that front ajax exists
 */
function ucBloxComponentCheckAjaxFront(){
	
	$action = UniteFunctionsUC::getPostGetVariable("action", "", UniteFunctionsUC::SANITIZE_KEY);
		
	if($action != GlobalsUC::PLUGIN_NAME."_ajax_action")
		return(false);
	
	$objActions = new UniteCreatorActions();
	$objActions->onAjaxFrontAction();
}

//check ajax, in case that ajax exists, exit here
ucBloxComponentCheckAjaxFront();


$app = JFactory::getApplication();
$document = JFactory::getDocument();
$menuitem = $app->getMenu()->getActive(); // get the active item

$params = null;
if(isset($menuitem->params))
	$params = $menuitem->params;

$menuitem = (array)$menuitem;
$query = UniteFunctionsUC::getVal($menuitem, "query");
$view = UniteFunctionsUC::getVal($query,"view");
if(empty($view))
	$view = UniteFunctionsUC::getPostGetVariable("view", "", UniteFunctionsUC::SANITIZE_KEY);


//---- set page title

$title = UniteFunctionsUC::getVal($menuitem, "title");

$pageTitle = null;

if(!empty($params))
	$pageTitle = $params->get("page_title");


if(!empty($pageTitle))
	$title = $pageTitle;

$pageTitlePos = $app->get('sitename_pagetitles', 0);

	if(empty($title))
		$title = $app->get('sitename');
	elseif ($pageTitlePos == 1)
		$title = JText::sprintf('JPAGETITLE', $app->get('sitename'), $title);
	elseif ($pageTitlePos == 2)
		$title = JText::sprintf('JPAGETITLE', $title, $app->get('sitename'));

	
$document->setTitle($title);

switch($view){
	case "layouts":
		require "views/layout.php";
	break;
	case "layout_preview":
		require "views/layout_preview_front.php";
	break;
	default:
		throw new Exception("Wrong view: ". $view);
	break;
}

?>