<?php
/**
 * @package Blox Page Builder
 * @author UniteCMS.net
 * @copyright (C) 2017 Unite CMS, All Rights Reserved. 
 * @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 * */
defined('APP_INC') or die('Restricted access');

class FunctionsStandAlone{

	/**
	 * check if ssl by php methods
	 */
	public static function isSSL() {
		
	    if ( isset($_SERVER['HTTPS']) ) {
	        if ( 'on' == strtolower($_SERVER['HTTPS']) )
	            return true;
	        if ( '1' == $_SERVER['HTTPS'] )
	            return true;
	    } elseif ( isset($_SERVER['SERVER_PORT']) && ( '443' == $_SERVER['SERVER_PORT'] ) ) {
	        return true;
	    }
	    return false;
	}	
	
	
	/**
	 * throw error
	 */
	public static function throwError($message,$code=null){
		if(!empty($code))
			throw new Exception($message);
		else
			throw new Exception($message);
	}
	
	/**
	 * get value from array. if not - return alternative
	 */
	public static function getVal($arr,$key,$altVal=""){
		
		if(isset($arr[$key]))
		  return($arr[$key]);
		
		return($altVal);
	}
	
	
	/**
	 * get session var
	 */
	public static function getSessionVar($name, $base){
		
		if(empty($base))
			self::throwError("Can't get session var without the base");
		
		if(!isset($_SESSION))
			return("");
		
		$arrBase = self::getVal($_SESSION, $base);
				
		if(empty($arrBase))
			return("");
			
		$value = self::getVal($arrBase, $name);
		
		return($value);
	}
	

	/**
	 * convert path to unix format slashes
	 */
	public static function pathToUnix($path){
		$path = str_replace('\\', '/', $path);
		$path = preg_replace('/\/+/', '/', $path); // Combine multiple slashes into a single slash
		
		return($path);
	}
	
	
	/**
	 * require mysql object
	 */
	public static function requireMySql(){
		
		$filepathMySql = GlobalsStandAlone::$pathBase."blox-plugin/admin/inc_php/framework/mysql.class.php";
		require_once $filepathMySql;
		
	}
	
	/**
	 * get get variable
	 */
	public static function getGetVar($name, $initVar = "", $sanitizeType = null){
		
		$var = $initVar;
		if(isset($_GET[$name])) 
			$var = $_GET[$name];
		
		//$var = UniteProviderFunctionsUC::sanitizeVar($var, $sanitizeType);
		
		return($var);
	}
	
	

}