<?php

defined("APP_INC") or die("Restricted Access");

class GlobalsStandAlone{
	
	const SESSION_BASE = "blox_data";
	const VIEW_STANDALONE_LOGIN = "stand_alone_login";
	const VIEW_STANDALONE_RESET_PASSWORD = "reset_password";
	const VIEW_STANDALONE_USERS = "users";
	const VIEW_STANDALONE_ADMIN_PROFILE = "admin_profile";
	const VIEW_STANDALONE_UPDATE = "update";
	const VIEW_STANDALONE_MEDIA = "media";
	
	
	public static $pathBase;
	public static $pathViews;
	public static $urlBase;
	public static $urlCss;
	public static $urlJS;
	public static $urlImages;
	public static $isRewriteUrl = false;
	
	public static $urlAdmin;
	public static $urlFront;
	
	public static $pathPlugin;
	public static $tablePrefix = "";
	public static $isAdmin = false;
	public static $showTrace = false;
	public static $isLocal;
	public static $isInstalled = false;
	public static $loggedInUser;
	public static $isLoggedIn = false;
	
	public static $urlInstaller;
	public static $pathInstaller;
	public static $pathInstallerViews;
	
	public static $tableUsers = "addonlibrary_users";
	public static $adminTitle;
	public static $arrAdminToolbarButtons;
	public static $currentAdminView;
	public static $productActivationCodeType;
	
	
	/**
	 * print all globals variables
	 */
	public static function printVars(){
		
		$methods = get_class_vars( "GlobalsStandAlone" );
		dmp($methods);
		exit();
	}
	
	
	/**
	 * init the is installed var
	 */
	public static function initIsInstalled(){
		
		$pathConfig = self::$pathBase."config.php";
		if(file_exists($pathConfig) == false)
			return(false);
		
		require_once $pathConfig;
			
		if(!defined("BLOX_DB_HOST"))
			return(false);
					    
			
		self::$isInstalled = true;
	}
	
	
	/**
	 * init loggenin user
	 */
	public static function initLoggedInUser(){
				    
		$user = FunctionsStandAlone::getSessionVar("user", self::SESSION_BASE);
		
		if(empty($user))
			return(false);
		
		self::$loggedInUser = $user;
		self::$isLoggedIn = true;
		
	}
	
	
	/**
	 * init globals after all other globals
	 */
	public static function initGlobalsAfter(){
		
		if(GlobalsUC::$isProductActive == false)
			return(false);
			
		$webAPI = new UniteCreatorWebAPI();			
		self::$productActivationCodeType = $webAPI->getActivationCodeType();
				
	}
	
	
	/**
	 * init the globals
	 */
	public static function initGlobals(){

		HelperStandAlone::setDefaultTimezone();
			
		if(defined("IS_BLOX_ADMIN"))
			self::$isAdmin = true;
		else 
			self::$isAdmin = false;
		
		//set path
		self::$pathBase = realpath(dirname(__FILE__)."/..")."/";
		self::$pathBase = FunctionsStandAlone::pathToUnix(self::$pathBase);
		
		self::$pathViews = self::$pathBase."views/";

		//set url
        $prefix = "http://";
        if (FunctionsStandAlone::isSSL()) {
            $prefix = "https://";
        }

        $urlDir = dirname($_SERVER['SCRIPT_NAME'])."/";
        
        if(self::$isAdmin == true)
			$urlDir = rtrim($urlDir, '/admin/')."/";
        else
		if(defined("IS_INSTALLER"))
			$urlDir = rtrim($urlDir, '/install/')."/";
                
        $urlBase = $prefix.$_SERVER['HTTP_HOST'] . $urlDir;
        
        
		self::$urlBase = $urlBase;
		
		self::$urlCss = self::$urlBase."css/";
		self::$urlJS = self::$urlBase."js/";
		self::$urlImages = self::$urlBase."images/";
		
		self::$urlAdmin = self::$urlBase."admin/";
		self::$urlFront = self::$urlBase;
		
		self::$pathPlugin = self::$pathBase."blox-plugin/";
		
		self::$pathInstaller = self::$pathBase."install/";
		self::$pathInstallerViews = self::$pathInstaller."views/";

		
		//set is local
		self::$isLocal = false;
		$serverName = $_SERVER["SERVER_NAME"];
		if($serverName == "localhost")
			self::$isLocal = true;

		if(self::$isLocal == true)
			self::$showTrace = true;
		
		self::$urlInstaller = self::$urlBase."install/";
		
		self::initIsInstalled();
				
		//set url rewrite
		self::$isRewriteUrl = true;
				
		//self::printVars();
	}

	
}


GlobalsStandAlone::initGlobals();
