<?php

defined("APP_INC") or die("Restricted Access");

class HelperStandAlone{

	/**
	 * set default timezone
	 */
	public static function setDefaultTimezone(){
		
		$timezone = @date_default_timezone_get();
		if(empty($timezone))
			$timezone = "UTC";
			
        date_default_timezone_set($timezone);
				
	}
	

	/**
	 * get menu array
	 */
	public static function getArrPanelMenu(){
		
		$view = UniteCreatorAdmin::getView();
		
		$arrPanelMenu = array();
		
		$arrPanelMenu[GlobalsUC::VIEW_LAYOUTS_LIST] = __("My Pages", BLOXBUILDER_TEXTDOMAIN);
		$arrPanelMenu[GlobalsUC::VIEW_ADDONS_LIST] = __("My Addons", BLOXBUILDER_TEXTDOMAIN);
		$arrPanelMenu[GlobalsUC::VIEW_LIBRARY] = __("My Library", BLOXBUILDER_TEXTDOMAIN);
		$arrPanelMenu[GlobalsStandAlone::VIEW_STANDALONE_MEDIA] = __("Media", BLOXBUILDER_TEXTDOMAIN);
		$arrPanelMenu[GlobalsUC::VIEW_SETTINGS] = __("General Settings", BLOXBUILDER_TEXTDOMAIN);
		$arrPanelMenu[GlobalsUC::VIEW_LAYOUTS_SETTINGS] = __("Layouts Settings", BLOXBUILDER_TEXTDOMAIN);
		$arrPanelMenu[GlobalsUC::VIEW_LICENSE] = __("License", BLOXBUILDER_TEXTDOMAIN);
		$arrPanelMenu[GlobalsStandAlone::VIEW_STANDALONE_ADMIN_PROFILE] = __("User Profile", BLOXBUILDER_TEXTDOMAIN);
		$arrPanelMenu[GlobalsStandAlone::VIEW_STANDALONE_UPDATE] = __("Update Blox", BLOXBUILDER_TEXTDOMAIN);
		
		$arrPanelMenu["logout"] = __("Log Out", BLOXBUILDER_TEXTDOMAIN);
		
		return($arrPanelMenu);
	}

	/**
	 * get admin page title
	 */
	public static function getAdminPageTitle(){
		
		$title = GlobalsStandAlone::$adminTitle;
		
		return($title);
	}
	
	/**
	 * do logout
	 */
	public static function doLogout(){
		
		UniteFunctionsUC::setSessionVar("user", null, GlobalsStandAlone::SESSION_BASE);
		GlobalsStandAlone::$isLoggedIn = false;
		GlobalsStandAlone::$loggedInUser = null;
	}
	
	/**
	 * get admin custom css
	 */
	public static function getAdminCustomCss(){
		
		$document = JFactory::getDocument();
		
		$arrCss = $document->arrCss;
		$strCss = implode("\n", $arrCss);
				
		return($strCss);
	}
	
	/**
	 * put admin custom css
	 */
	public static function putAdminCustomCss(){
		
		$css = self::getAdminCustomCss();
		if(empty($css))
			return(false);
		
		?>
		<style type="text/css">
		<?php 
		echo $css;
		?>
		</style>
		<?php 
	}
	
	
	/**
	 * get admin custom scripts array
	 */
	public static function getAdminCustomScriptsArray(){
		
		$document = JFactory::getDocument();
		
		$arrJs = $document->arrJS;
		if(is_string($arrJs))
			$arrJs = array($arrJs);
		
		return($arrJs);
	}
	
	
	
	/**
	 * store sessions user
	 */
	public static function doLoginUser($arrUser){
		
		UniteFunctionsUC::validateNotEmpty($arrUser, "user array");
		
		UniteFunctionsUC::setSessionVar("user", $arrUser, GlobalsStandAlone::SESSION_BASE);
		
		GlobalsStandAlone::$isLoggedIn = true;
		GlobalsStandAlone::$loggedInUser = $arrUser;
	}
	
	/**
	 * store sessions user
	 */
	public static function doLogoutAction($arrUser){
		
		UniteFunctionsUC::validateNotEmpty($arrUser, "user array");
		
		UniteFunctionsUC::setSessionVar("user", $arrUser, GlobalsStandAlone::SESSION_BASE);
		
		GlobalsStandAlone::$isLoggedIn = true;
		GlobalsStandAlone::$loggedInUser = $arrUser;
	}
	
	
	
	/**
	 * redirect to admin
	 */
	public static function redirectToAdmin(){
		
		UniteFunctionsUC::redirectToUrl(GlobalsStandAlone::$urlAdmin);
	}
	
	/**
	 * redirect to installer
	 */
	public static function redirectToInstaller(){
		
		$urlInstaller = GlobalsStandAlone::$urlInstaller;
		
	    header("Location: $urlInstaller");
	    exit;
	}
	
	/**
	 * validate db connection
	 */
	public static function validateDBConnection(){
		
		$db = new UniteCreatorDB();
	}
	
	/**
	 * put joomla options html in header part
	 */
	public static function putHtmlAdminJoomlaOptions(){
		
		$urlRoot = GlobalsStandAlone::$urlBase;
		$urlEditorPlugins = $urlRoot."js/editor/js/plugins/";
		
		$urlEditorPlugins = str_replace("/", "\\/", $urlEditorPlugins);
		
		?>
	<script type="application/json" class="joomla-script-options new">{"system.paths":{"root":"\/joomla","base":"\/joomla\/administrator"},"plg_editor_tinymce":{"tinyMCE":{"editor1":{"joomlaMergeDefaults":true,"joomlaExtButtons":{"names":["button-0Module | ","button-1Menu | ","button-2Contact | ","button-3Article | ","button-4Image | "],"script":["!(function(){\n\t\t\t\tvar getBtnOptions = new Function(\"return {handler: \\'iframe\\', size: {x: 800, y: 500}}\"),\n\t\t\t\t\tbtnOptions = getBtnOptions(),\n\t\t\t\t\tmodalWidth = btnOptions.size && btnOptions.size.x ?  btnOptions.size.x : null,\n\t\t\t\t\tmodalHeight = btnOptions.size && btnOptions.size.y ?  btnOptions.size.y : null;\n\t\t\t\teditor.addButton(\"button-0Module\", {\n\t\t\t\t\ttext: \"Module\",\n\t\t\t\t\ttitle: \"Module\",\n\t\t\t\t\ticon: \"none icon-file-add\",\n\t\t\t\t\tonclick: function () {\n\t\t\t\t\t\t\tvar modalOptions = {\n\t\t\t\t\t\t\t\ttitle  : \"Module\",\n\t\t\t\t\t\t\t\turl : 'http:\/\/localhost\/joomla\/administrator\/index.php?option=com_modules&amp;view=modules&amp;layout=modal&amp;tmpl=component&amp;editor=unite_setting_1536837287_hy0cq_editor1&amp;e1a2a3e69dbb0bee8be01c2a1b3262f6=1',\n\t\t\t\t\t\t\t\tbuttons: [{\n\t\t\t\t\t\t\t\t\ttext   : \"Close\",\n\t\t\t\t\t\t\t\t\tonclick: \"close\"\n\t\t\t\t\t\t\t\t}]\n\t\t\t\t\t\t\t}\n\t\t\t\t\t\t\tif(modalWidth){\n\t\t\t\t\t\t\t\tmodalOptions.width = modalWidth;\n\t\t\t\t\t\t\t}\n\t\t\t\t\t\t\tif(modalHeight){\n\t\t\t\t\t\t\t\tmodalOptions.height = modalHeight;\n\t\t\t\t\t\t\t}\n\t\t\t\t\t\t\teditor.windowManager.open(modalOptions);\n\t\t\t\t\t}\n\t\t\t\t});\n\t\t\t})();","!(function(){\n\t\t\t\tvar getBtnOptions = new Function(\"return {handler: \\'iframe\\', size: {x: 800, y: 500}}\"),\n\t\t\t\t\tbtnOptions = getBtnOptions(),\n\t\t\t\t\tmodalWidth = btnOptions.size && btnOptions.size.x ?  btnOptions.size.x : null,\n\t\t\t\t\tmodalHeight = btnOptions.size && btnOptions.size.y ?  btnOptions.size.y : null;\n\t\t\t\teditor.addButton(\"button-1Menu\", {\n\t\t\t\t\ttext: \"Menu\",\n\t\t\t\t\ttitle: \"Menu\",\n\t\t\t\t\ticon: \"none icon-share-alt\",\n\t\t\t\t\tonclick: function () {\n\t\t\t\t\t\t\tvar modalOptions = {\n\t\t\t\t\t\t\t\ttitle  : \"Menu\",\n\t\t\t\t\t\t\t\turl : 'http:\/\/localhost\/joomla\/administrator\/index.php?option=com_menus&amp;view=items&amp;layout=modal&amp;tmpl=component&amp;e1a2a3e69dbb0bee8be01c2a1b3262f6=1&amp;editor=unite_setting_1536837287_hy0cq_editor1',\n\t\t\t\t\t\t\t\tbuttons: [{\n\t\t\t\t\t\t\t\t\ttext   : \"Close\",\n\t\t\t\t\t\t\t\t\tonclick: \"close\"\n\t\t\t\t\t\t\t\t}]\n\t\t\t\t\t\t\t}\n\t\t\t\t\t\t\tif(modalWidth){\n\t\t\t\t\t\t\t\tmodalOptions.width = modalWidth;\n\t\t\t\t\t\t\t}\n\t\t\t\t\t\t\tif(modalHeight){\n\t\t\t\t\t\t\t\tmodalOptions.height = modalHeight;\n\t\t\t\t\t\t\t}\n\t\t\t\t\t\t\teditor.windowManager.open(modalOptions);\n\t\t\t\t\t}\n\t\t\t\t});\n\t\t\t})();","!(function(){\n\t\t\t\tvar getBtnOptions = new Function(\"return {handler: \\'iframe\\', size: {x: 800, y: 500}}\"),\n\t\t\t\t\tbtnOptions = getBtnOptions(),\n\t\t\t\t\tmodalWidth = btnOptions.size && btnOptions.size.x ?  btnOptions.size.x : null,\n\t\t\t\t\tmodalHeight = btnOptions.size && btnOptions.size.y ?  btnOptions.size.y : null;\n\t\t\t\teditor.addButton(\"button-2Contact\", {\n\t\t\t\t\ttext: \"Contact\",\n\t\t\t\t\ttitle: \"Contact\",\n\t\t\t\t\ticon: \"none icon-address\",\n\t\t\t\t\tonclick: function () {\n\t\t\t\t\t\t\tvar modalOptions = {\n\t\t\t\t\t\t\t\ttitle  : \"Contact\",\n\t\t\t\t\t\t\t\turl : 'http:\/\/localhost\/joomla\/administrator\/index.php?option=com_contact&amp;view=contacts&amp;layout=modal&amp;tmpl=component&amp;e1a2a3e69dbb0bee8be01c2a1b3262f6=1&amp;editor=unite_setting_1536837287_hy0cq_editor1',\n\t\t\t\t\t\t\t\tbuttons: [{\n\t\t\t\t\t\t\t\t\ttext   : \"Close\",\n\t\t\t\t\t\t\t\t\tonclick: \"close\"\n\t\t\t\t\t\t\t\t}]\n\t\t\t\t\t\t\t}\n\t\t\t\t\t\t\tif(modalWidth){\n\t\t\t\t\t\t\t\tmodalOptions.width = modalWidth;\n\t\t\t\t\t\t\t}\n\t\t\t\t\t\t\tif(modalHeight){\n\t\t\t\t\t\t\t\tmodalOptions.height = modalHeight;\n\t\t\t\t\t\t\t}\n\t\t\t\t\t\t\teditor.windowManager.open(modalOptions);\n\t\t\t\t\t}\n\t\t\t\t});\n\t\t\t})();","!(function(){\n\t\t\t\tvar getBtnOptions = new Function(\"return {handler: \\'iframe\\', size: {x: 800, y: 500}}\"),\n\t\t\t\t\tbtnOptions = getBtnOptions(),\n\t\t\t\t\tmodalWidth = btnOptions.size && btnOptions.size.x ?  btnOptions.size.x : null,\n\t\t\t\t\tmodalHeight = btnOptions.size && btnOptions.size.y ?  btnOptions.size.y : null;\n\t\t\t\teditor.addButton(\"button-3Article\", {\n\t\t\t\t\ttext: \"Article\",\n\t\t\t\t\ttitle: \"Article\",\n\t\t\t\t\ticon: \"none icon-file-add\",\n\t\t\t\t\tonclick: function () {\n\t\t\t\t\t\t\tvar modalOptions = {\n\t\t\t\t\t\t\t\ttitle  : \"Article\",\n\t\t\t\t\t\t\t\turl : 'http:\/\/localhost\/joomla\/administrator\/index.php?option=com_content&amp;view=articles&amp;layout=modal&amp;tmpl=component&amp;e1a2a3e69dbb0bee8be01c2a1b3262f6=1&amp;editor=unite_setting_1536837287_hy0cq_editor1',\n\t\t\t\t\t\t\t\tbuttons: [{\n\t\t\t\t\t\t\t\t\ttext   : \"Close\",\n\t\t\t\t\t\t\t\t\tonclick: \"close\"\n\t\t\t\t\t\t\t\t}]\n\t\t\t\t\t\t\t}\n\t\t\t\t\t\t\tif(modalWidth){\n\t\t\t\t\t\t\t\tmodalOptions.width = modalWidth;\n\t\t\t\t\t\t\t}\n\t\t\t\t\t\t\tif(modalHeight){\n\t\t\t\t\t\t\t\tmodalOptions.height = modalHeight;\n\t\t\t\t\t\t\t}\n\t\t\t\t\t\t\teditor.windowManager.open(modalOptions);\n\t\t\t\t\t}\n\t\t\t\t});\n\t\t\t})();","!(function(){\n\t\t\t\tvar getBtnOptions = new Function(\"return {handler: \\'iframe\\', size: {x: 800, y: 500}}\"),\n\t\t\t\t\tbtnOptions = getBtnOptions(),\n\t\t\t\t\tmodalWidth = btnOptions.size && btnOptions.size.x ?  btnOptions.size.x : null,\n\t\t\t\t\tmodalHeight = btnOptions.size && btnOptions.size.y ?  btnOptions.size.y : null;\n\t\t\t\teditor.addButton(\"button-4Image\", {\n\t\t\t\t\ttext: \"Image\",\n\t\t\t\t\ttitle: \"Image\",\n\t\t\t\t\ticon: \"none icon-pictures\",\n\t\t\t\t\tonclick: function () {\n\t\t\t\t\t\t\tvar modalOptions = {\n\t\t\t\t\t\t\t\ttitle  : \"Image\",\n\t\t\t\t\t\t\t\turl : 'http:\/\/localhost\/joomla\/administrator\/index.php?option=com_media&amp;view=images&amp;tmpl=component&amp;e_name=unite_setting_1536837287_hy0cq_editor1&amp;asset=&amp;author=',\n\t\t\t\t\t\t\t\tbuttons: [{\n\t\t\t\t\t\t\t\t\ttext   : \"Close\",\n\t\t\t\t\t\t\t\t\tonclick: \"close\"\n\t\t\t\t\t\t\t\t}]\n\t\t\t\t\t\t\t}\n\t\t\t\t\t\t\tif(modalWidth){\n\t\t\t\t\t\t\t\tmodalOptions.width = modalWidth;\n\t\t\t\t\t\t\t}\n\t\t\t\t\t\t\tif(modalHeight){\n\t\t\t\t\t\t\t\tmodalOptions.height = modalHeight;\n\t\t\t\t\t\t\t}\n\t\t\t\t\t\t\teditor.windowManager.open(modalOptions);\n\t\t\t\t\t}\n\t\t\t\t});\n\t\t\t})();"]}},"default":{"setCustomDir":"\/joomla","mediaUploadPath":"","uploadUri":"http:\/\/localhost\/joomla\/administrator\/index.php?option=com_media&task=file.upload&tmpl=component&2c75ccb068b04f8be93ae1df4182a592=o1o54fv3qee88kqhtneu6qul57&e1a2a3e69dbb0bee8be01c2a1b3262f6=1&asset=image&format=json","suffix":".min","baseURL":"\/joomla\/media\/editors\/tinymce","directionality":"ltr","language":"en","autosave_restore_when_empty":false,"skin":"lightgray","theme":"modern","schema":"html5","menubar":"edit insert view format table tools","toolbar1":"bold italic underline strikethrough | alignleft aligncenter alignright alignjustify | styleselect | formatselect fontselect fontsizeselect | searchreplace | bullist numlist | outdent indent | undo redo | link unlink anchor image | code | forecolor backcolor | fullscreen | table | subscript superscript | charmap emoticons media hr ltr rtl | cut copy paste pastetext | visualchars visualblocks nonbreaking blockquote template | print preview codesample insertdatetime removeformat","toolbar2":null,"plugins":"autolink,lists,save,colorpicker,importcss,searchreplace,link,anchor,image,code,textcolor,fullscreen,table,charmap,emoticons,media,hr,directionality,paste,visualchars,visualblocks,nonbreaking,template,print,preview,codesample,insertdatetime,wordcount,advlist,autosave,contextmenu","inline_styles":true,"gecko_spellcheck":true,"entity_encoding":"raw","verify_html":true,"valid_elements":"","extended_valid_elements":"hr[id|title|alt|class|width|size|noshade]","invalid_elements":"script,applet,iframe","relative_urls":true,"remove_script_host":false,"content_css":"","document_base_url":"\/joomla\/","paste_data_images":true,"importcss_append":true,"image_title":true,"height":"200","width":"","resize":"both","templates":[{"title":"Layout","description":"HTML layout.","url":"\/joomla\/media\/editors\/tinymce\/templates\/layout1.html"},{"title":"Simple Snippet","description":"Simple HTML snippet.","url":"\/joomla\/media\/editors\/tinymce\/templates\/snippet1.html"}],"image_advtab":true,"external_plugins":{"jdragdrop":"<?php echo $urlEditorPlugins?>dragdrop\/plugin.min.js"},"force_br_newlines":false,"force_p_newlines":true,"forced_root_block":"p","rel_list":[{"title":"None","value":""},{"title":"Alternate","value":"alternate"},{"title":"Author","value":"author"},{"title":"Bookmark","value":"bookmark"},{"title":"Help","value":"help"},{"title":"License","value":"license"},{"title":"Lightbox","value":"lightbox"},{"title":"Next","value":"next"},{"title":"No Follow","value":"nofollow"},{"title":"No Referrer","value":"noreferrer"},{"title":"Prefetch","value":"prefetch"},{"title":"Prev","value":"prev"},{"title":"Search","value":"search"},{"title":"Tag","value":"tag"}],"toolbar_items_size":"small"}}},"joomla.jtext":{"PLG_TINY_ERR_UNSUPPORTEDBROWSER":"Drag and drop image upload is not available for your browser. Please consider using a fully HTML5 compatible browser."}}</script>
		<?php 
	}
	
	
	/**
	 * put admin scripts and styles
	 */
	public static function putAdminScriptIncludes(){
		
		$document = JFactory::getDocument();
		
		//put css includes
		
		$arrStyles = $document->_styleSheets;
		$htmlCss = HelperHtmlUC::getHtmlCssIncludes($arrStyles);
		
		echo "<!-- admin css includes -->\n";
		echo $htmlCss;
		
		//---- scripts array
		
		echo "<!-- admin js includes -->\n";
		
		$arrScripts = $document->_scripts;
		$htmlJs = HelperHtmlUC::getHtmlJsIncludes($arrScripts);
		
		
		echo $htmlJs;
	}
	
	
	/**
	 * put admin footer scripts
	 */
	public static function putAdminFooterScripts(){
		
		$document = JFactory::getDocument();
		
		$arrScripts = $document->arrJS;
		if(empty($arrScripts))
			return(false);
		
		$html = HelperHtmlUC::getHtmlCustomScripts($arrScripts);
		
		?>
		<!-- Blox Scripts -->
		
		<?php echo $html?>
		
		<?php 
		
		
	}
	
	/**
	 * check if tables exists
	 */
	public static function isTablesExists(){
	    
	    $db = new UniteCreatorDB();
	    
	    //UniteFunctionsUC::showTrace();
	    
	    $arrTables = array(
	        GlobalsUC::$table_addons,
	        GlobalsUC::$table_categories,
	        GlobalsUC::$table_layouts,
	        "addonlibrary_options",
	        "addonlibrary_users"
	    );
	    
	    foreach($arrTables as $table){
	        
	        $isExists = $db->isTableExists($table);
	        if($isExists == false)
	            return(false);
	       	        
	    }
	    
	     return(true);
	}
	
	
	/**
	 * validate that tables exists
	 */
	public static function validateTablesExists(){
	    
	     $isExists = self::isTablesExists();
	    
	     if($isExists == false)
	          self::redirectToInstaller();
	     
	}
	
	public static function validateUserExists(){
	    
	    $objUsers = new UniteCreatorUsers();
	    $totalUsers = $objUsers->getTotalUsers();
	    
	    if(empty($totalUsers))
	        self::redirectToInstaller();
	}
	
	
	/**
	 * if not installed - redirect to installer
	 */
	public static function validateIsInstalled(){
			    
		if(GlobalsStandAlone::$isInstalled == false)
			self::redirectToInstaller();
			
		self::validateDBConnection();
		
		
	}
	
		/**
		 * put menu panel
		 */
		public static function putPanelMenu($arrMenu){
						
			if(empty($arrMenu))
				return(false);
			
			$currentView = UniteCreatorAdmin::getView();
						
			$urlLogout = UniteFunctionsUC::addUrlParams(GlobalsStandAlone::$urlAdmin, "logout_action=true");
			
			?>
			
			<ul>
			<?php 
			foreach($arrMenu as $view=>$title){
				
				$class = "";
				if($view == $currentView)
					$class = "class='current'";
				
				$link = HelperUC::getViewUrl($view);
				
				if($view == "logout")
					$link = $urlLogout;
				
				if($view == GlobalsUC::VIEW_LICENSE)
					$link = HelperUC::getViewUrl(GlobalsUC::VIEW_LICENSE,"envato=true");
				
					
				?>
				<li <?php echo $class?>>
				<a href="<?php echo $link?>"><?php echo $title?></a>
				</li>
				<?php 
			}
			?>
			</ul>
			
			<?php 
		}
	
	
}