<?php


/* ------------------------------------------------- */

function jimport(){
}

/* ------------------------------------------------- */

class JControllerLegacy{
	
	
	/**
	 * run task
	 */
	public function runTask($task){
		
		$isExists = method_exists($this, $task);
		
		call_user_func(array($this, $task));
	}
	
	
}

/* ------------------------------------------------- */

class JRoute{

	/**
	 * make some route :)
	 */
	public static function _($url, $param){
		return($url);
	}
}

/* ------------------------------------------------- */

class Document{
	
	public $_styleSheets = array();
	public $_scripts = array();
	public $title;
	public $arrTags = array();
	public $arrCss = array();
	public $arrJS = array();
	
	
	/**
	 * construct
	 */
	public function __construct(){
				
	}
	
	/**
	 * add script declaration
	 */
	public function addScriptDeclaration($script){
		
		$this->arrJS[] = $script;
		
	}
	
	/**
	 * add html to head
	 */
	public function addCustomTag($html){
		
		$this->arrTags[] = $html;
		
	}
	
	/**
	 * add style css
	 */
	public function addStyleDeclaration($style){
		
		$this->arrCss[] = $style;
	}
	
	/**
	 * add script
	 */
	public function addScript($script, $handle=""){
				
		if(empty($handle))
			$handle = HelperUC::convertTitleToHandle($script);
				
		if(isset($this->_scripts[$handle]))
			return(false);
			
		$this->_scripts[$handle] = $script;
	}
	
	
	/**
	 * set page title
	 */
	public function setTitle($title){
		
		$this->title = $title;
		
	}
	
	public function addStyleSheet($style, $handle="", $someting="", $attribs=""){
		
		if(empty($handle))
			$handle = HelperUC::convertTitleToHandle($style);
		
		if(isset($this->_styleSheets[$handle]))
			return(false);
			
		$this->_styleSheets[$handle] = $style;
	}
	
}

/* ------------------------------------------------- */

class JViewLegacy{
	
	public $_layout;
	public $document;
	
	
	/**
	 * construct the view
	 */
	public function __construct(){
		$this->document = new Document();
		$this->_layout = GlobalsPanel::$layout;
			
	}
	
	
	/**
	 * display
	 */
	public function display($tpl = null){
		
		if(!empty($this->_layout) && $this->_layout != GlobalsPanel::$layout)
			GlobalsPanel::$layout = $this->_layout;
		
		$pathTemplate = HelperPanel::getPathMarketTemplate(GlobalsPanel::$view, GlobalsPanel::$layout);
		
		require $pathTemplate;
		
		//exit();
	}
	
	/**
	 * set layout
	 */
	public function setLayout($layout = ""){
		
		if(empty($layout))
			return(false);
		
		$this->_layout = $layout;
		GlobalsPanel::$layout = $layout;
	}
	
}

class Params{
	
	private $params;
	
	public function __construct(){
		$this->params = array();
	}
	
	/**
	 * set params
	 */
	public function setParams($arrParams){
		$this->params = $arrParams;
	}
	
	/**
	 * get param
	 */
	public function get($name, $default, $filter=""){
		
		$value = FunctionsPanel::getVal($this->params, $name, $default);
		
		return($value);
	}
	
	
	/**
	 * set param
	 */
	public function set($name, $value){
		
		$this->params[$name] = $value;
		
	}
	
}

/* ------------------------------------------------- */

/**
 * application class
 *
 */

/* ------------------------------------------------- */

class Application{
	
	public $input;
	
	/**
	 * get application
	 */
	public function __construct(){
		
		$this->input = new Params();
		
		$this->input->setParams($_REQUEST);
		
	}
	
}





class JURI{
	
	/**
	 * get root url
	 */
	public static function root(){
		
		$urlRoot = GlobalsPanel::$urlBase;
		
		return($urlRoot);
	}
	
	
}


/* ------------------------------------------------- */

/**
 * session class
 *
 */

class Session{
	
	
	/**
	 * get session with some namespace
	 */
	public function get($name, $default, $namespace = ""){
				
		if(empty($namespace)){
			$arr = FunctionsPanel::getSessionVar($user);
			if(empty($arr))
				$arr = array();
			
			return($arr);
		}

		$arrNamespace = FunctionsPanel::getSessionVar($namespace);
		$arr = FunctionsPanel::getVal($arrNamespace, $name);
		
		if(empty($arr))
			$arr = array();
		
		return($arr);
	}
	
	/**
	 * set session value
	 */
	public function set($name, $value, $namespace=null){
		
		if(empty($namespace)){
			$_SESSION[$name] = $value;
			return(false);
		}
		
		$arrNamespace = FunctionsPanel::getSessionVar($namespace);
		if(empty($arrNamespace))
			$arrNamespace = array();
			
		$arrNamespace[$name] = $value;
		
		$_SESSION[$namespace] = $arrNamespace;
	}

	/**
	 * clear
	 */
	public function clear($name, $namespace=""){
		
		if(!empty($namespace))
			unset($_SESSION[$namespace][$name]);
		else
			unset($_SESSION[$name]);
		
	}
	
}

/* ------------------------------------------------- */

class UCMailer extends PHPMailer{
	
	
	/**
	 * send mail
	 */
	public function sendMail($from, $fromName, $emaiTo, $subject, $body, $replyTo = null, $replyToName = null){
		
		$subject = trim($subject);
		$body = trim($body);
		
		$this->Subject = $subject;
		$this->Body = $body;

		// Are we sending the email as HTML?
		$this->IsHTML(true);
		
		$this->addAddress($emaiTo);
		
		// Take care of reply email addresses
		if (is_array($replyTo))
		{
			$numReplyTo = count($replyTo);

			for ($i = 0; $i < $numReplyTo; $i++)
			{
				$this->addReplyTo(array($replyTo[$i], $replyToName[$i]));
			}
		}
		elseif (isset($replyTo))
		{
			$this->addReplyTo(array($replyTo, $replyToName));
		}

		// Add sender to replyTo only if no replyTo received
		$autoReplyTo = (empty($this->ReplyTo)) ? true : false;
		
		if(!empty($from))
			$this->setFrom($from, $fromName, $autoReplyTo);
		
		return $this->Send();
	}
	
}

/* ------------------------------------------------- */



/**
 * jfactory class
 *
 */
class JFactory{

	public static $session;
	public static $application;
	public static $phpMailer;
	public static $document;
	
	
	/**
	 * get session function
	 */
	public static function getSession(){
		
		if(empty(self::$session))
			self::$session = new Session();
		
		return(self::$session);
	}
	
	
	/**
	 * get mailer
	 */
	public static function getMailer(){
		
		if(empty(self::$phpMailer))
			self::$phpMailer = new UCMailer();
		
		return(self::$phpMailer);
	}
	
	
	/**
	 * get application
	 */
	public static function getApplication(){
		
		if(empty(self::$application)){
			self::$application = new Application();
			return(self::$application);
		}
		
	}
	
	/**
	 * get document
	 */
	public static function getDocument(){
		
		if(empty(self::$document))
			self::$document = new Document();
		
		return(self::$document);
	}
	
	
}

/* ------------------------------------------------- */

/**
 * jtext
 *
 */
class JText{
	
	/**
	* output text
	 */
	public static function _($text){
		
		return($text);
	}
	
}

/* ------------------------------------------------- */

/**
 * JToolBarHelper
 *
 */
class JToolBarHelper{
	
	
	/**
	 * set title
	 */
	public static function title($text, $icon){
		
		if(empty(GlobalsStandAlone::$adminTitle))
			GlobalsStandAlone::$adminTitle = $text;
		
	}
	
}

/* ------------------------------------------------- */

/**
 * JToolbar
 *
 */

class JToolbar{
	
	public static $toolbar;
	
	
	/**
	 * get instance
	 */
	public static function getInstance($name){
		
		if(empty(self::$toolbar))
			self::$toolbar = new JToolbar();

		
		return(self::$toolbar);
	}
	
	
	/**
	 * append button
	 */
	public function appendButton($type, $html, $name){
		
		GlobalsStandAlone::$arrAdminToolbarButtons[] = array(
			"type" => $type,
			"html" => $html,
			"name" => $name
		);
		
	}
	
	
}

/* ------------------------------------------------- */

/**
 * JEditor
 *
 */
class JEditor{
	
	public static $editor;
	
	/**
	 * get instance
	 */
	public static function getInstance(){
		
		if(empty(self::$editor))
			self::$editor = new JEditor();
		
		return(self::$editor);
	}
	
	/**
	 * add scripts to the editor
	 */
	private function addScripts(){
		
		HelperUC::addScriptAbsoluteUrl(GlobalsStandAlone::$urlJS."joomla_core.js", "joomla-core");
		
		HelperUC::addScriptAbsoluteUrl(GlobalsStandAlone::$urlJS."editor/tinymce.min.js", "editor_tinymce");
		HelperUC::addScriptAbsoluteUrl(GlobalsStandAlone::$urlJS."editor/js/tinymce.min.js", "joomla_editor_tinymce");
		HelperUC::addScriptAbsoluteUrl(GlobalsStandAlone::$urlJS."editor/js/tiny-close.min.js", "joomla_editor_tinyclose");
		
		
	}
	
	
	/**
	 * display the editor
	 */
	public function display($id, $name="", $width="100%", $height=200, $initText = "",$something2,$something3=true,$something4=null,$something5=null,$something6=null,$params=null){
		
		$this->addScripts();
		
		$initText = htmlspecialchars($initText);
		
		?>
		
		<div class="js-editor-tinymce">
								
			<textarea
				name="<?php echo $name?>"
				id="<?php echo $id?>"
				cols="5"
				rows="3"
				style="width: <?php echo $width?>; height: <?php echo $height?>px;"
				class="mce_editable joomla-editor-tinymce"
			><?php echo $initText?></textarea>
		
		</div>
		
		
		<?php 
	}
	
	
}

$editor = JEditor::getInstance("tinymce");
