<?php

defined("APP_INC") or die("Restricted Access");

class UniteProviderDBUC{

	private static $objMySql;

	/**
	 * init mysql objects
	 */
	private function initObjects(){
		
		if(GlobalsStandAlone::$isInstalled == false)
			return(false);
        
		if(!empty(self::$objMySql))
			return(false);
			
       	self::$objMySql = new UniteMySql();
        	
        if(GlobalsStandAlone::$isInstalled == true)
            self::$objMySql->connect(BLOX_DB_HOST, BLOX_DB_USERNAME, BLOX_DB_PASSWORD, BLOX_DB_NAME);			
				
	}
	
	
	/**
	 *
	 * constructor - set database object
	 */
	public function __construct(){
				
		$this->initObjects();
		
	}
	
	/**
	 * test connection, return true or false
	 */
	public function testConnection($host, $username, $password, $dbName){
		
		try{
			
			$objMySql = new UniteMySql();
			$objMySql->connect($host, $username, $password, $dbName);
			
		}catch(Exception $e){
			return(null);
		}
		
		return($objMySql);
	}
	
	/**
	 * get the db object
	 * @return UniteMySql
	 */
	public function getDBObject(){
	    
	    return(self::$objMySql);
	}
	
	/**
	 * get error number
	 */
	public function getErrorNum(){
		
		if(empty(self::$objMySql))
			return(0);
		
		return self::$objMySql->getErrorNumber();
	}
	
	
	/**
	 * get error message
	 */
	public function getErrorMsg(){
		
		if(empty(self::$objMySql))
			return(false);
		
		return self::$objMySql->getErrorMsg();
	}
	
	
	/**
	 * get last row insert id
	 */
	public function insertid(){
		
		return self::$objMySql->insertid();
	}
	
	/**
	 * do sql query, return success
	 */
	public function query($query){
		
		if(empty(self::$objMySql))
			return(false);
		
		$success = self::$objMySql->query($query);
				
		return($success);
	}
	
	
	/**
	 * get affected rows after operation
	 */
	public function getAffectedRows(){
		
		if(empty(self::$objMySql))
			return(0);
		
		return self::$objMySql->getAffectedRows();
	}
	
	
	/**
	 * fetch objects from some sql
	 */
	public function fetchSql($query){
		
		if(empty(self::$objMySql))
			return(array());
			
		$rows = self::$objMySql->getQueryArr($query, "fetch sql");
		
		return($rows);
	}
	
	
	/**
	 * escape some string
	 */
	public function escape($string){
		
		if(empty(self::$objMySql))
			return($string);
		
		return self::$objMySql->escape($string);
	}
    
    
}