<?php

defined('INSTALLER_INC') or die('Restricted access');

class HelperInstaller{
	
	
	/**
	 * get path instlaler view
	 */
	public static function getPathView($view){
		
		$pathView = GlobalsStandAlone::$pathInstallerViews.$view.".php";
		
		UniteFunctionsUC::validateFilepath($pathView, "view path");
		
		return($pathView);
	}
	
	
	/**
	 * 
	 * check if user installed
	 */
	public static function isUserInstalled(){
		
		$objUsers = new UniteCreatorUsers();
		$totalUsers = $objUsers->getTotalUsers();
		
		if(empty($totalUsers))
			return(false);
		
		return(true);
	}
	
	
	/**
	 * validate that the app is not installed 
	 */
	public static function isDBInstalled(){
	    
		return GlobalsStandAlone::$isInstalled;
	}
	
	
	/**
	 * redirect to site
	 */
	public static function redirectToSite(){
				
		UniteFunctionsUC::redirectToUrl(GlobalsStandAlone::$urlBase);
		exit();
	}
	
	
	/**
	 * redirect to site
	 */
	public static function redirectToAdmin(){
		
		
		UniteFunctionsUC::redirectToUrl(GlobalsStandAlone::$urlAdmin);
		exit();
	}
	
	
	/**
	 * redirect to step2
	 */
	private static function redirectToInstaller(){
		
		$url = GlobalsStandAlone::$urlInstaller."?step=2";
		
		UniteFunctionsUC::redirectToUrl($url);
		exit();
	}
	
	
	/**
	 * install DB
	 */
	public static function installDB($objMySql){
        
		
		//install blox db
		$filepath = GlobalsStandAlone::$pathInstaller."sql/install.sql";
		
		$query = file_get_contents($filepath);
		
		$query = str_replace("#__", '', $query);
		
        $objMySql->multiQueries($query);
        
	}
	
	
	/**
	 * write config file
	 */
	public static function writeConfigFile($host, $username, $password, $dbName){
            
		$content = "<?php \n"; 
		$content .= " define('BLOX_DB_HOST', '{$host}');\n ";
		$content .= " define('BLOX_DB_PASSWORD', '{$password}');\n";
		$content .= " define('BLOX_DB_USERNAME', '{$username}');\n";
		$content .= " define('BLOX_DB_NAME', '{$dbName}');\n ";
		
		$pathConfig = GlobalsStandAlone::$pathBase."config.php";
		
		UniteFunctionsUC::writeFile($content, $pathConfig);
	}
	
	
	/**
	 * check submit step2
	 */
	public static function checkStep2Submit(){
		
		if(empty($_POST))
			return(false);
		
		$isInstall = UniteFunctionsUC::getPostVariable("create_user","",UniteFunctionsUC::SANITIZE_KEY);
		$isInstall = UniteFunctionsUC::strToBool($isInstall);
			
		if($isInstall == false)
			return(false);

		$username = UniteFunctionsUC::getPostVariable("username", "", UniteFunctionsUC::SANITIZE_TEXT_FIELD);
		
		UniteFunctionsUC::validateNotEmpty($username, __("user name", BLOXBUILDER_TEXTDOMAIN));
		UniteFunctionsUC::validateAlphaNumeric($username, __("user name",BLOXBUILDER_TEXTDOMAIN));
		
		$password = UniteFunctionsUC::getPostVariable("password", "", UniteFunctionsUC::SANITIZE_NOTHING);
		$passwordTrimmed = trim($password);
		if($passwordTrimmed != $password)
			UniteFunctionsUC::throwError(__("The password should not start or end with space", BLOXBUILDER_TEXTDOMAIN));
		
		$passwordRepeat = UniteFunctionsUC::getPostVariable("password_repeat", "", UniteFunctionsUC::SANITIZE_NOTHING);
		
		if($password != $passwordRepeat)
			UniteFunctionsUC::throwError(__("The passwords not match!", BLOXBUILDER_TEXTDOMAIN));
		
		$maxPassLetters = 5;
		$numPassLetters = strlen($password);
		if($numPassLetters < $maxPassLetters)
			UniteFunctionsUC::throwError("The password has to be minimum {$maxPassLetters} letters");
		
		$email = UniteFunctionsUC::getPostVariable("email", "", UniteFunctionsUC::SANITIZE_TEXT_FIELD);
		
		$isValid = UniteFunctionsUC::isEmailValid($email);
		
		if($isValid == false)
			UniteFunctionsUC::throwError(__("The email not valid!", BLOXBUILDER_TEXTDOMAIN));
		
		$objUsers = new UniteCreatorUsers();
		$objUsers->insertUser($username, $password, $email);
		
		
		self::redirectToInstaller();
	}
	
	/**
	 * only install db
	 */
	public static function installDBOnly(){
	    
	    $objDB = new UniteCreatorDB();
	    $objMySql = $objDB->getPDB();
	    
	    self::installDB($objMySql);
	    	    
	}
	
	/**
	 * check step1 submit
	 */
	public static function checkStep1Submit(){
		
		if(empty($_POST))
			return(false);
		
		$isInstall = UniteFunctionsUC::getPostVariable("install_db","",UniteFunctionsUC::SANITIZE_KEY);
		$isInstall = UniteFunctionsUC::strToBool($isInstall);
		
		if($isInstall == false)
			return(false);
		
		//get all data
			
        $host = UniteFunctionsUC::getPostVariable("dbhost", "", UniteFunctionsUC::SANITIZE_TEXT_FIELD);
        $dbName = UniteFunctionsUC::getPostVariable("dbname", "", UniteFunctionsUC::SANITIZE_TEXT_FIELD);
        $username = UniteFunctionsUC::getPostVariable("uname", "", UniteFunctionsUC::SANITIZE_TEXT_FIELD);
        $password = UniteFunctionsUC::getPostVariable("pwd", "", UniteFunctionsUC::SANITIZE_TEXT_FIELD);
        
		UniteFunctionsUC::validateNotEmpty($host, __("host name",BLOXBUILDER_TEXTDOMAIN));
		UniteFunctionsUC::validateNotEmpty($dbName, __("database name",BLOXBUILDER_TEXTDOMAIN));
		UniteFunctionsUC::validateNotEmpty($username, __("user name",BLOXBUILDER_TEXTDOMAIN));
        
		//test connection
		
		$objDB = new UniteProviderDBUC();
		$objMySql = $objDB->testConnection($host, $username, $password, $dbName);
		
		if(empty($objMySql))
			UniteFunctionsUC::throwError(__("Failed Connecting to Database", BLOXBUILDER_TEXTDOMAIN));

		//check if db table exists
		$isExists = $objMySql->isTableExists(GlobalsStandAlone::$tableUsers);
		if($isExists == true)
			UniteFunctionsUC::throwError(__("The table already exists, please delete old tables and try again.", BLOXBUILDER_TEXTDOMAIN));
		
		//install DB
		self::installDB($objMySql);
		
		//write config file
		self::writeConfigFile($host, $username, $password, $dbName);
		
		//redirect to add user data
		self::redirectToInstaller();
	}
	
}