<?php 
defined("INSTALLER_INC") or die("Restricted Access");

$title = __("Step 2 - Create Admin User | Blox", BLOXBUILDER_TEXTDOMAIN);

$username = UniteFunctionsUC::getPostGetVariable("username", "", UniteFunctionsUC::SANITIZE_TEXT_FIELD);
$email = UniteFunctionsUC::getPostGetVariable("email", "", UniteFunctionsUC::SANITIZE_TEXT_FIELD);

if(!isset($error))
	$error = null;

require GlobalsStandAlone::$pathInstallerViews . 'header.php';


?>

<div class="install step2">
	
    <h3><?php _e("Information needed", BLOXBUILDER_TEXTDOMAIN)?></h3>
    
    <hr>
    
    <form action="<?php echo GlobalsStandAlone::$urlInstaller ?>" id="install_form" method="post">
    
    	<input type="hidden" name="create_user" value="true">
    	
        <p><?php _e("Please provide the following information. Don't worry, you can always change these settings later.", BLOXBUILDER_TEXTDOMAIN)?></p>
        <table class="table  install-table">
            <tbody>
            <tr>
                <th>
                    <label for="input_username"><?php _e("Username", BLOXBUILDER_TEXTDOMAIN)?> <span class="setting_required">*</span></label>
                </th>
                <td>
                    <input type="text" size="25" class="form-control" id="input_username" name="username" value="<?php echo $username?>">
                </td>
            </tr>
            <tr>
                <th><label for="input_password"><?php _e("Your Password", BLOXBUILDER_TEXTDOMAIN)?> <span class="setting_required">*</span></label></th>
                <td>
                    <input type="password" autocomplete="off" value="" id="input_password" class="form-control" name="password">
                </td>
            </tr>
            <tr>
                <th><label for="input_password_repeat"><?php _e("Repeat Password", BLOXBUILDER_TEXTDOMAIN)?>  <span class="setting_required">*</span></label></th>
                <td>
                    <input type="password" autocomplete="off" value="" id="input_password_repeat" class="form-control" name="password_repeat">
                </td>
            </tr>

            <tr>
                <th><label for="input_email"><?php _e("Your Email", BLOXBUILDER_TEXTDOMAIN)?> <span class="setting_required">*</span></label></th>
                <td><input type="email" id="input_email" size="25" class="form-control" name="email" value="<?php echo $email?>"></td>
            </tr>
            </tbody>
        </table>
        
		<?php if(!empty($error)):?>
        
        <div class="installer-error error-body">
        	<?php echo $error?>
        </div>
        
        <?php endif?>
        
        <p class="step formRow-bottom">
            <input type="submit" class="btn btn-success" value="<?php _e("Create User", BLOXBUILDER_TEXTDOMAIN)?>" name="submit">
        </p>
    </form>
</div>

<?php

require GlobalsStandAlone::$pathInstallerViews . 'footer.php';

