<?php
/**
 * @package Blox Page Builder
 * @author UniteCMS.net
 * @copyright (C) 2017 Unite CMS, All Rights Reserved. 
 * @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 * */
defined("APP_INC") or die("Restricted Access");


/**
 * media manager view
 *
 */
class UniteCreatorViewAdminProfile{

	public $showHeader = true;
	protected $record;
	
	
	/**
	 * get headre text
	 */
	protected function getHeaderText(){
		
		$headerTitle = __("Admin User Profile", BLOXBUILDER_TEXTDOMAIN);
		
		return($headerTitle);
	}
	
	
	
	/**
	 * put header
	 */
	protected function putHtmlHeader(){
		
		if($this->showHeader == true){
			
			$headerTitle = $this->getHeaderText();
			
			require HelperUC::getPathTemplate("header");
		}else
			require HelperUC::getPathTemplate("header_missing");
		
	}

	/**
	 * put scripts
	 */
	private function putScripts(){
		
		HelperUC::addScriptAbsoluteUrl(GlobalsStandAlone::$urlJS."unitecreator_admin_adminprofile.js", "edit-admin-profile");
		
	}
	
	
	/**
	 * get user settings
	 */
	private function getObjSettings(){
		
		$user = new UniteCreatorUsers();
		$record = $user->getCurrentUserRecord();
		$this->record = $record;
				
		//$userID = UniteFunctionsUC::getVal($record, "id");
		
		$username = UniteFunctionsUC::getVal($record, "username");
		$fullname = UniteFunctionsUC::getVal($record, "fullname");
		$email = UniteFunctionsUC::getVal($record, "email");
		
		
		$settings = new UniteCreatorSettings();
		//$settings->addHiddenInput("userid", $userID);
		
		$settings->addTextBox("username", $username, __("User Name",BLOXBUILDER_TEXTDOMAIN));
		$settings->addTextBox("fullname", $fullname, __("Full Name",BLOXBUILDER_TEXTDOMAIN));
		$settings->addTextBox("email", $email, __("Email",BLOXBUILDER_TEXTDOMAIN));
		$settings->addTextBox("password", "", __("Password",BLOXBUILDER_TEXTDOMAIN), array(
			"ispassword"=>true,
			"description"=>__("Leave empty if you don't want to change", BLOXBUILDER_TEXTDOMAIN)));
		
		
		return($settings);
	}
	
	
	/**
	 * put html
	 */
	public function putHtml(){
		
		$this->putScripts();
		
		$this->putHtmlHeader();
		
		$settings = $this->getObjSettings();
		
		$name = UniteFunctionsUC::getVal($this->record, "fullname");
		if(empty($name))
			$name = UniteFunctionsUC::getVal($this->record, "username");
		if(empty($name))
			$name = UniteFunctionsUC::getVal($this->record, "email");
			
			
		?>
				
		<div class="content_wrapper unite-content-wrapper">

		<h2><?php _e("Edit User", BLOXBUILDER_TEXTDOMAIN)?> - <?php echo $name?></h2>
		
		<?php 
			HelperHtmlUC::drawSettings($settings,"user_settings");
			
			$prefix = "users_settings";
			$buttonTitle = __("Save User", BLOXBUILDER_TEXTDOMAIN);
			$loaderTitle = __("Saving...", BLOXBUILDER_TEXTDOMAIN);
			$successTitle = __("User Saved", BLOXBUILDER_TEXTDOMAIN);
			HelperHtmlUC::putDialogActions($prefix, $buttonTitle, $loaderTitle, $successTitle);
			
		?>
				
		
		</div>
		
		<?php 
	}
	
	
}


$objViewAdminProfile = new UniteCreatorViewAdminProfile();
$objViewAdminProfile->putHtml();
